#!/bin/sh
/bin/mount -a


rm -rf /tmp/adsl_starttime

/usr/sbin/mknod_util amazon_se-port /dev/amazon_se-port 

/usr/sbin/swreset &



if [ -r /etc/rc.d/config.sh ]; then
	. /etc/rc.d/config.sh
fi

if [ "$IFX_CONFIG_LOW_FOOTPRINT" = "1" ]; then

    echo 8192 > /proc/sys/net/ipv4/route/max_size
    echo 1024 > /proc/sys/net/ipv4/ip_conntrack_max
fi


if [ "$IFX_ADSL_FIRMWARE_IN_ROOTFS" != "1" ]; then
	if [ "`/bin/dd if=/dev/mtd/1 bs=4 count=1`" = "sqlz" ] ; then
		echo "Mount ADSL Firmware Now"
		/bin/mount /firmware
	elif [ "`/bin/dd if=/dev/mtd/1 bs=4 count=1`" = "sqsh" ] ; then
		echo "Mount ADSL Firmware Now"
		/bin/mount /firmware
	else
		echo "ADSL Firmware Not Found"
	fi
fi


if [ -r /etc/rc.d/config.sh ]; then
	. /etc/rc.d/config.sh
fi

if [ -r /etc/rc.conf ]; then
        . /etc/rc.conf
fi


/usr/sbin/mknod_util dsl_cpe_api /dev/dsl_cpe_api
/usr/sbin/mknod_util ifx_mei /dev/ifx_mei
echo "0" > /tmp/adsl_status
if [ "$IFX_CONFIG_CUSTOM_BOARD_SUPPORT" = "1" ]; then
	/usr/sbin/ledconfig off
else
	/usr/sbin/led_control -l 2 off
fi

if [ -r /firmware/modemhwe.bin ]; then
   /etc/rc.d/rc.bringup_adsl_start
else
	echo "Not able to locate ADSL FW image in MTD partition, try to use the FW image from rootfs instead!!"
	/usr/sbin/dsl_cpe_control -i -f /root/modemhwe.bin &
fi


touch /ramdisk/flash/passwd
i=0
while [ $i -lt $passFileLineCount ]
do
	eval passVar='$passFileLineCount'$i
	echo $passVar >> /ramdisk/flash/passwd
	i=`expr $i + 1`
done

insmod ifx_nfext_core
insmod ifx_nfext_ppp

if [ "$IFX_CONFIG_SNMPv1" = "1" ]; then
	IFX_CONFIG_SNMP_AGENT="1"
elif [ "$IFX_CONFIG_SNMPv3" = "1" ]; then
	IFX_CONFIG_SNMP_AGENT="1"
elif [ "$IFX_CONFIG_DSL_MANAGEMENT" = "1" ]; then
	IFX_CONFIG_SNMP_AGENT="1"
fi

if [ "$IFX_CONFIG_SNMP_AGENT" = "1" ]; then
	echo "######  V1 Configuration  ######" > /etc/snmp/snmpd.conf
	echo "rocommunity	$SNMProcommunity" >> /etc/snmp/snmpd.conf
	echo "rwcommunity	$SNMPrwcommunity" >> /etc/snmp/snmpd.conf
	if [ "$SNMPTrapEnable" = "1" ]; then
		echo "trapsink	$SNMPTrapIP  $SNMPTrapCommunity  $SNMPTrapPort" >> /etc/snmp/snmpd.conf
		echo "trapcommunity $SNMPTrapCommunity " >> /etc/snmp/snmpd.conf
		echo "authtrapenable	1" >> /etc/snmp/snmpd.conf
	else
		echo "#trapsink	$SNMPTrapIP  $SNMPTrapCommunity  $SNMPTrapPort" >> /etc/snmp/snmpd.conf
	fi
	echo "######  V3 Configuration  ######" >> /etc/snmp/snmpd.conf
fi

if [ "$IFX_VLAN_SUPPORT" = "1" ]; then
	/bin/mknod /dev/vlan c 69 0
fi

if [ "$IFX_ADM6996_UTILITY" = "1" ]; then
	/bin/mknod /dev/adm6996 c 69 0
	/sbin/insmod admmod
fi


/sbin/ifconfig lo 127.0.0.1 netmask 255.0.0.0

echo 1 > /proc/sys/net/ipv4/ip_forward

echo "127.0.0.1	localhost.localdomain localhost" > /etc/hosts

i=0
while [ $i -lt $lan_main_Count ]
do
	eval ip='$lan_main_'$i'_ipAddr'
	echo "$ip ${hostname} `echo ${hostname} |cut -f1 -d.`" >> /etc/hosts
	i=`expr $i + 1`
done

if [ -f /usr/sbin/dnrd ]; then
	rm -rf /ramdisk/etc/dnrd
	mkdir /ramdisk/etc/dnrd
	/usr/sbin/dnrd
fi

if [ -f /bin/hostname ]; then
	/bin/hostname $hostname
fi

if [ -f /sbin/syslogd ]; then
	echo "Bringing up syslog"
	if [ "$system_log_mode" = "1" -o "$system_log_mode" = "2" ]; then
		if [ -n "$system_log_IP" -a "$system_log_IP" != "0.0.0.0" ]; then
			if [ -n "$system_log_port" -a "$system_log_port" != "0" ]; then
				if [ "$system_log_mode" = "2" ]; then
					/sbin/syslogd -L -s $IFX_CONFIG_SYSTEM_LOG_BUFFER_SIZE -b $IFX_CONFIG_SYSTEM_LOG_BUFFER_COUNT -R $system_log_IP:$system_log_port -l $system_log_log_level
				else
					/sbin/syslogd -s $IFX_CONFIG_SYSTEM_LOG_BUFFER_SIZE -b $IFX_CONFIG_SYSTEM_LOG_BUFFER_COUNT -R $system_log_IP:$system_log_port -l $system_log_log_level
				fi
			else
				if [ "$system_log_mode" = "2" ]; then
					/sbin/syslogd -L -s $IFX_CONFIG_SYSTEM_LOG_BUFFER_SIZE -b $IFX_CONFIG_SYSTEM_LOG_BUFFER_COUNT 0 -R $system_log_IP -l $system_log_log_level
				else
					/sbin/syslogd -s $IFX_CONFIG_SYSTEM_LOG_BUFFER_SIZE -b $IFX_CONFIG_SYSTEM_LOG_BUFFER_COUNT 0 -R $system_log_IP -l $system_log_log_level
				fi
			fi
		fi
	else
		/sbin/syslogd -s $IFX_CONFIG_SYSTEM_LOG_BUFFER_SIZE -b $IFX_CONFIG_SYSTEM_LOG_BUFFER_COUNT -l $system_log_log_level
	fi
fi

if [ -f /sbin/klogd ]; then
	echo "Bringing up klogd"
	/sbin/klogd &
fi

if [ "$IFX_CONFIG_TR69_DEVICE" = "1" ]; then
	i=0
	while [ $i -lt $lan_main_Count ]
	do
		eval iface='$lan_main_'$i'_interface'
		/usr/sbin/brctl addbr $iface
		/usr/sbin/brctl setfd br0 1
		/usr/sbin/brctl addif $iface eth0 
		/usr/sbin/brctl stp $iface off
		i=`expr $i + 1`
	done
	/sbin/ifconfig eth0 0.0.0.0 up

	/etc/rc.d/rc.bringup_lan start

	if [ -f /etc/rc.d/udhcpc.script ]; then
		. /etc/rc.d/init.d/udhcpc start 0
	fi

	/sbin/route add default dev br0
else
	if [ "$IFX_CONFIG_NAPT" = "1" ]; then
		if [ -f /usr/sbin/naptcfg ]; then
			/usr/sbin/naptcfg --FWinit > /dev/null
			/usr/sbin/naptcfg --NAPTinit > /dev/null
			/usr/sbin/naptcfg --MACFilterinit > /dev/null
			/usr/sbin/naptcfg --PacketFilterinit > /dev/null
	 		/usr/sbin/naptcfg --ServicesACLinit > /dev/null
		fi
	fi

	i=0
	while [ $i -lt $lan_main_Count ]
	do
		eval iface='$lan_main_'$i'_interface'
		/usr/sbin/brctl addbr $iface
		/usr/sbin/brctl setfd br0 1
		/usr/sbin/brctl addif $iface eth0 
		/usr/sbin/brctl stp $iface off
		i=`expr $i + 1`
	done
	#806131:<IFTW-leon> Let board accessing by eth0 before ppa ready
	/sbin/ifconfig eth0 0.0.0.0 up

	/etc/rc.d/rc.bringup_lan start

	if [ "$IFX_CONFIG_A4" = "1" ]; then
		#806131:<IFTW-leon> Let board accessing by eth0 before ppa ready start
		/usr/sbin/brctl delif br0 eth0
		/sbin/ifconfig br0 0.0.0.0 down
		/usr/sbin/status_oper SET Lan1_IF_Info STATUS DOWN
	
		/sbin/ifconfig eth0 $lan_main_0_ipAddr netmask $lan_main_0_netmask up
		/usr/sbin/status_oper SET Lan1_IF_Info STATUS "UP" IP "$lan_main_0_ipAddr" MASK "$lan_main_0_netmask"
		/usr/sbin/naptcfg --ADDLAN eth0
		/usr/sbin/naptcfg --Servicesinit
		#806131:<IFTW-leon> Let board accessing by eth0 before  ppa ready end
	fi

	# Move this to DSL Link Up handling
	# For autosearch PVC
	#if  [ "$IFX_CONFIG_AUTOSEARCH" = "1" ]; then
	#if [ -e /usr/sbin/autosearch_main ]; then
	#echo "Autosearch PVc is running"
	#/usr/sbin/autosearch_main &
	#fi

	#
	# Setup QOS
	#
	if  [ "$IFX_CONFIG_QOS" = "1" ]; then
		/etc/rc.d/init.d/qos init 
	fi

	#if [ "$IFX_CONFIG_CLIP" = "1" ]; then
	#	/usr/sbin/atmarpd -b -l /dev/null
	#fi

	if [ "$IFX_CONFIG_NAPT" = "1" ]; then
		/etc/rc.d/rc.firewall start
		/usr/sbin/naptcfg --VSinit > /dev/null
		/usr/sbin/naptcfg --PMinit > /dev/null
		/usr/sbin/naptcfg --DMZinit > /dev/null
		/usr/sbin/naptcfg --VS 1 > /dev/null
		/usr/sbin/naptcfg --PM 1 > /dev/null

		if [ "$DMZ_ENABLE" = "1" ]; then
			/usr/sbin/naptcfg --DMZ 1 > /dev/null
		fi

		if [ "$ipnat_enable" = "1" ]; then
			/usr/sbin/naptcfg --NAPT 1 > /dev/null
		else
			/usr/sbin/naptcfg --NAPT 0 > /dev/null
		fi
	fi
fi

/etc/rc.d/rc.bringup_services start

if [ -z "$IFX_CONFIG_TR69_DEVICE" -o "$IFX_CONFIG_TR69_DEVICE" = "0" ]; then
	if [  "$ipnat_enable" = "1" -a "$IFX_CONFIG_ALGS" = "1" ]; then
		/etc/rc.d/init.d/algs start
	fi


	/usr/sbin/status_oper SET "wan_con_index" "windex" "" 


	#804281:<IFTW-fchang>.added
	if [ "$IFX_CONFIG_A4" = "1" ]; then
		insmod amazon_se_ppa_ppe_a4_hal.o
		insmod ifx_ppa_api.o
	fi


	/etc/rc.d/rc.bringup_wan start &

	/usr/sbin/status_oper SET "http_wan_vcc_select" "WAN_VCC" "1"
	/usr/sbin/status_oper SET "wan_main" "ipoption_wan" "UNKNOWN" "WAN_VCC" "0/0"
	#echo "0" > /tmp/adsl_status
fi

/usr/sbin/version.sh -r&

echo "nameserver 168.95.1.1" > /etc/resolv.conf

if [ "$IFX_CONFIG_USB_DEVICE" = "1" ]; then
	#/usr/sbin/usb_util &

	if [ "$IFX_CONFIG_USB_DEVICE_MODULE" = "1" ]; then
		/sbin/insmod dwc_otg_gadget.o
        	board_mac=`/usr/sbin/upgrade mac_get 0`
        	/sbin/insmod g_ether.o dev_addr="$board_mac"
        fi
           
	#/sbin/insmod g_ether.o
	#/sbin/insmod g_ether.o idVendor=0x07A6 idProduct=0x4610
	/usr/sbin/brctl addif $lan_main_0_interface usb0
	/sbin/ifconfig usb0 0.0.0.0 up
fi
if [ "1$IFX_CONFIG_USB_HOST" = "11" ]; then
	# using IFX8015 usb<->ethernet by default in kernel mode
	/usr/sbin/brctl addif $lan_main_0_interface eth1
	/sbin/ifconfig eth1 0.0.0.0 up
fi

if [ "$IFX_CONFIG_IPv6" = "1" -a "$ipv6_status" = "1" ]; then
kernel_version=`version.sh -k`
/sbin/insmod /lib/modules/${kernel_version}/kernel/net/ipv6/ipv6.o
fi





if  [ "$IFX_CONFIG_ALLNET" = "1" ]; then
	/usr/sbin/iptables -I PREROUTING -t nat -p tcp --dport 8235 -j REDIRECT --to-port 80
	/usr/sbin/iptables -I PREROUTING -t nat -p tcp --dport 80 -j DROP
fi

mknod /dev/mem c 1 1
mem -us 0x1e104114 -w 0x80000010


echo
echo "+---------------------------------------------------+"
echo "| Linux/MIPS on AMAZON_SE by Infineon COM AC BB_CPE |"
echo "+---------------------------------------------------+"


