#!/bin/sh

CURRENT_TC_LAYER=0
cat /proc/modules|grep amazon_se_ppe
if [ "$?"  = "0" ]; then
	CURRENT_TC_LAYER=ATM
fi
cat /proc/modules|grep amazon_se_ptm
if [ "$?"  = "0" ]; then
	CURRENT_TC_LAYER=EFM
fi

# DSL Event handling script - Triggered from DSL CPE control Application
case "$DSL_NOTIFICATION_TYPE" in
	DSL_STATUS)
	if [ "$DSL_TC_LAYER_STATUS" = "ATM" ]; then
		if [ "$CURRENT_TC_LAYER" = "0" ]; then
			/sbin/insmod amazon_se_ppe.o
		fi
		if [ "$CURRENT_TC_LAYER" = "EFM" ]; then
			/sbin/rmmod amazon_se_ptm
			/sbin/insmod amazon_se_ppe.o
		fi
	elif [ "$DSL_TC_LAYER_STATUS" = "EFM" ]; then
		if [ "$CURRENT_TC_LAYER" = "0" ]; then
			/sbin/insmod amazon_se_ptm.o
		fi
		if [ "$CURRENT_TC_LAYER" = "ATM" ]; then
			/sbin/rmmod amazon_se_ppe
			/sbin/insmod amazon_se_ptm.o
		fi
	fi
	;;

	DSL_INTERFACE_STATUS)
	case "$DSL_INTERFACE_STATUS" in 
		"UP")
		# DSL link up trigger		
		TMPFILE="/tmp/up.txt"

               if [ ! -f $TMPFILE ]; then
               echo "1" > $TMPFILE
               else
               NUM=`cat $TMPFILE`
               NUM=`expr $NUM + 1`
               echo "$NUM" > $TMPFILE
               fi
		echo "xDSL Enter SHOWTIME!!"
		. /etc/rc.d/adsl_up
                # Wait for 1 sec & initate the autosearch now
                #sleep 1
		# Invoke autosearch right after ADSL reaches ShowTime
                #if [ -e /usr/sbin/autosearch_main ]; then
                #        echo "Autosearch PVc is now Running..."
                #        /usr/sbin/autosearch_main &
                #fi
		# Enable Far-End Parameter Request
		/usr/sbin/dsl_cpe_pipe.sh ifcs 0 0 0 0 0 0
		cp /proc/uptime /tmp/adsl_starttime 
		;;

		"DOWN")
		# DSL link down trigger
		echo "xDSL Leave SHOWTIME!!"
		. /etc/rc.d/adsl_down 
		;;
	esac
	;;

	DSL_DATARATE_STATUS_US)
	echo "DSL US Data Rate = "`expr $DSL_DATARATE_US_BC0 / 1000`" kbps"
	# echo "DSL DS Data Rate = "`expr $DSL_DATARATE_DS_BC0 / 1000`" kbps"
	# convert the upstream data rate in kbps to cells/sec and store in running config file
	# this will be used for bandwidth allocation during wan connection creation
	# 8 * 53 = 424
	DSL_DATARATE_US_CPS=`expr ${DSL_DATARATE_US_BC0} / 424`
	/usr/sbin/status_oper SET BW_INFO max_us_bw "${DSL_DATARATE_US_CPS}"
	# Adjust ATM and IP QoS Rate shaping parameters based on line rate
	#. /etc/rc.d/init.d/qos_rate_update 
	# This is handled in ADSL UP Event
	;;
esac

