#ifndef AMAZON_SE_SPI_ECOS_H
#define AMAZON_SE_SPI_ECOS_H

#include <asm/amazon_se/amazon_se_linux_to_ecos.h>

/*These error numbers are intended to be MIPS ABI compatible
defines from errorno.h */

#define EFAULT          14       /* Bad address */

#ifndef MOD_INC_USE_COUNT
#define MOD_INC_USE_COUNT
#endif

#ifndef MOD_DEC_USE_COUNT
#define MOD_DEC_USE_COUNT
#endif

#ifndef SPI_MINOR
#define SPI_MINOR 0
#endif

typedef unsigned long SPI_intstat_t;
typedef cyg_sem_t SPI_mutex_t;
typedef struct file SPI_file_t;
typedef struct inode SPI_inode_t;

/* spinloc related api */
#define SPI_MUTEX_INIT(id, flag)	cyg_semaphore_init(&id, flag) //Anath
#define SPI_MUTEX_LOCK(id)		cyg_semaphore_wait(&id)       //Anath
#define SPI_MUTEX_UNLOCK(id)		cyg_semaphore_post(&id)       //Anath

#endif // AMAZON_SE_SPI_ECOS_H
