/*****************************************************************************
 * DANUBE BootROM
 * Copyright (c) 2005, Infineon Technologies AG, All rights reserved
 * COM NRW CSE VoIP
 *****************************************************************************/

#ifndef __BSTRAP_H
#define __BSTRAP_H

#define BSTRAP_OK              0x00000000    /* Bootstrap succesful, start address in BOOT_RVEC */
#define BSTRAP_RESTART         0x00000001    /* Restart bootstrap with config in BOOT_CONFIG */
#define BSTRAP_ERR             0x80000000
#define BSTRAP_TAG_INVALID     (BSTRAP_ERR | 0x00000010)
#define BSTRAP_TAG_UNKNOWN     (BSTRAP_ERR | 0x00000020)
#define BSTRAP_FLAG_INVALID    (BSTRAP_ERR | 0x00000030)
#define BSTRAP_IF_CFG_INVALID  (BSTRAP_ERR | 0x00000040)
#define BSTRAP_IF_ERR          (BSTRAP_ERR | 0x00000050)
#define BSTRAP_MEM_ERR         (BSTRAP_ERR | 0x00000080)

/* Bootstrap interface required functions... */
typedef struct _boot_if
{
	int (*init)(void);                        /** Initialize interface with default values */
	int (*config)(u32* config);               /** Re-configure interface according to IFCFG */
	int (*read_block)(u32 *addr, int length); /** Read a single block of data */
	int (*terminate)(void);                   /** Terminate after last transfer */
} boot_if;

typedef int (*bstrap_config_t)(u32 *);
typedef int (*bstrap_init_t)(void);
typedef int (*bstrap_read_block_t)(u32 *addr, int length);
typedef int (*bstrap_terminate_t)(void);
//int bstrap_exec(boot_if *bif);
int bstrap_exec(bstrap_init_t init,bstrap_read_block_t read_block, bstrap_terminate_t terminate);

#endif /* #ifndef __BSTRAP_H */
