/*****************************************************************************
 * DANUBE BootROM
 * Copyright (c) 2005, Infineon Technologies AG, All rights reserved
 * IFAP DC COM SD
 *****************************************************************************/

#ifndef __SFLASH_EXTRA_H__
#define __SFLASH_EXTRA_H__

#define RDID                        0x9F
#define EWSR                        0x50
#define WRSR                        0x01
#define RDSR                        0x05

#define MXIC_MANUF_ID               0xC2
#define MXIC_SECTOR_SIZE            0x1000
//#define MXIC_D_SECTOR_SIZE            0x1000   //MX25L1605D, MX25L3205D
//#define MXIC_A_SECTOR_SIZE            0x10000   //MX25L3205A
#define MXIC_SECTOR_ERASE_CMD       0x20
#define MXIC_CHIP_ERASE_CMD         0x60
#define MXIC_PAGE_SIZE              256
#define MXIC_PAGE_WRITE_CMD         0x02

#define WINBOND_MANUF_ID           0xEF
#define WINBOND_SECTOR_SIZE        0x1000
#define WINBOND_SECTOR_ERASE_CMD   0x20
#define WINBOND_CHIP_ERASE_CMD     0xC7
#define WINBOND_PAGE_SIZE          256
#define WINBOND_PAGE_WRITE_CMD     0x02

typedef struct 
{
	u8 manuf_id;
	u8 device_id1;
	u8 device_id2;
   u32 sector_size;
   u8 sector_erase;
   u8 chip_erase;
   u32 page_size;
   u8 page_write;
} flash_type;


#endif
