/*****************************************************************************
 * DANUBE
 * Copyright (c) 2005, Infineon Technologies AG, All rights reserved
 * IFAP DC COM SD
 *****************************************************************************/

#include <common.h>
#include "asm/ifx_asc.h"
#include "boot.h"
#include "asm/ifx_mips.h"

#define FLAG_DEC	0x00020000
#define FLAG_SDBG	0x00080000

boot_data bootrom =
{
  1,   /** CPU number */
  0,   /** Boot configuration */
  0,   /** CPU endianess */
  0,   /** Debug mode */
  0};   /** application vector */

void _boot_rvec(void)
{
   if (*BOOT_RVEC(bootrom.cpu) == 0)
   {
      boot_error(BOOT_ERR_NO_RVEC);
   }
   else
   {
      void (*decrypt) (u32 addr, int n) = 0xbf0014e8;
      void (*start)(void) = (void *)*BOOT_RVEC(1);
      boot_set_status(BOOT_STAT_START, BOOT_STAT_MASK_STAT);
      if (*BOOT_CFG_STAT(bootrom.cpu) & FLAG_DEC)
      {
         u32 size = *BOOT_SIZE(bootrom.cpu);
         u32 addr = *BOOT_RVEC(bootrom.cpu);
         decrypt(addr, size);
      }
      start();
   }
}

void boot_error(u32 berr)
{
   int i;
   boot_set_status(BOOT_STAT_HALT, BOOT_STAT_MASK_STAT);
   boot_sdbg("** HALT, ", berr);
   while(1)
   {
      for (i = berr; i > 0; i--)
      {
         /* Toggle pin */
      }
      __asm__("nop;nop;nop;nop;nop;");
   }
}

void boot_sdbg(u8* string, u32 value)
{
  if (*BOOT_CFG_STAT(bootrom.cpu) & FLAG_SDBG)
  {
    puts(string);
    if (value)
    {
      printf("%d",value);
    }
    printf("\n\r");
  }
}

void boot_set_status(u32 status, u32 mask)
{
  *BOOT_CFG_STAT(bootrom.cpu) = (*BOOT_CFG_STAT(bootrom.cpu) & ~mask) | (status & mask);
}

void boot_cp1(void)
{
  int ret = 10;

  bootrom.cpu = 1;
  while (*BOOT_RVEC(bootrom.cpu) == 0);
  _boot_rvec();
  /* never get here...*/
  boot_error(ret);
}


