/* ============================================================================
 * Copyright (C) 2003[- 2004] ? Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon 
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 * 
 * ============================================================================
 *
 * File Name: ifx_extra_env.h
 * Author : Mars Lin (mars.lin@infineon.com)
 * Date: 
 *
 * ===========================================================================
 *
 * Project:
 * Block:
 *
 * ===========================================================================
 * Contents:  This file contains the data structures and definitions used 
 * 	      by the core iptables and the sip alg modules.
 * ===========================================================================
 * References:
 */
	"mem=" MK_STR(IFX_CONFIG_KERNEL_MEMORY_SIZE) "M\0"
   	"ipaddr=" IFX_CFG_UBOOT_DEFAULT_CFG_IPADDR "\0"
	"serverip=" IFX_CFG_UBOOT_DEFAULT_CFG_SERVERIP "\0"
	"ethaddr=" IFX_CFG_UBOOT_DEFAULT_CFG_ETHADDR "\0"
	"netdev=" IFX_CFG_UBOOT_DEFAULT_CFG_NETDEV "\0"
	"baudrate=" IFX_CFG_UBOOT_DEFAULT_CFG_BAUDRATE "\0"
	"rootpath=/opt/nfs\0"
	"nfsargs=setenv bootargs root=/dev/nfs rw nfsroot=$(serverip):$(rootpath)\0"
	"ramargs=setenv bootargs root=/dev/ram rw\0"
	"addip=setenv bootargs $(bootargs) ip=$(ipaddr):$(serverip):$(gatewayip):$(netmask):$(hostname):$(netdev):on\0"
	"addmisc=setenv bootargs $(bootargs) console=" IFX_CFG_UBOOT_DEFAULT_CFG_TTY ",$(baudrate) ethaddr=$(ethaddr) mem=$(mem) panic=1\0"
	"flash_nfs=run nfsargs addip addmisc;bootm $(kernel_addr)\0"
	"ramdisk_addr=B0100000\0"
	"flash_self=run ramargs addip addmisc;bootm $(kernel_addr) $(ramdisk_addr)\0"
	"bootfile=uImage\0"
#ifdef CONFIG_SPI
	"u-boot=u-boot-spi.bin\0"
#else
	"u-boot=u-boot.ifx\0"
#endif
	"firmware=firmware.img\0"
	"fullimage=ifx_adslrt.img\0"
	"net_nfs=tftp 80500000 $(bootfile);run nfsargs addip addmisc;bootm\0"
        "root_filesystem=rootfs.img\0"
	"load=tftp 80500000 $(u-boot)\0"
	"update=protect off 1:0-2;era 1:0-2;cp.b 80500000 " IFX_CFG_UBOOT_DEFAULT_CFG_FLASH_ADDRESS " $(filesize)\0"
	"flashargs=setenv bootargs root=" IFX_CFG_FLASH_ROOTFS_IMAGE_MTDBLOCK_NAME "\0"
	"flash_flash=run flashargs addip addmisc; bootm $(kernel_addr)\0"
#ifdef CONFIG_SPI
	"update_uboot=tftpboot 80400000 $(u-boot); erase_all; cp.b 80400000 00000000 $(filesize)\0"
#else
	"update_uboot=tftpboot 80400000 $(u-boot); erase all; cp.b 80400000 b0000000 $(filesize)\0"
#endif
	"update_kernel=tftpboot 80400000 $(bootfile);upgrade 80400000 $(filesize)\0"
	"update_rootfs=tftpboot 80400000 $(root_filesystem);upgrade 80400000 $(filesize)\0"
	"update_firmware=tftpboot 80400000 $(firmware);upgrade 80400000 $(filesize)\0"
	"update_fullimage=tftpboot 80400000 $(fullimage);upgrade 80400000 $(filesize)\0"
#ifdef CONFIG_SPI
	"reset_uboot_config=mw 80400000 'FFFFFFFF' " MK_STR(IFX_CFG_FLASH_UBOOT_CFG_SIZE)";cp.b 80400000 " MK_STR(IFX_CFG_FLASH_UBOOT_CFG_START_ADDR) " " MK_STR(IFX_CFG_FLASH_UBOOT_CFG_SIZE)";reset\0"
#else
	"reset_uboot_config=erase " MK_STR(IFX_CFG_FLASH_UBOOT_CFG_START_ADDR) " " MK_STR(IFX_CFG_FLASH_UBOOT_CFG_END_ADDR) " 1;erase $(f_rootfs_end) $(f_kernel_addr) 1\0" 
#endif
	IFX_CFG_FLASH_PARTITIONS_INFO
	"flash_end=" MK_STR(IFX_CFG_FLASH_END_ADDR) "\0"
	IFX_CFG_FLASH_DATA_BLOCKS_INFO
	"f_uboot_addr=" MK_STR(IFX_CFG_FLASH_UBOOT_IMAGE_START_ADDR) "\0"
	"f_uboot_size=" MK_STR(IFX_CFG_FLASH_UBOOT_IMAGE_SIZE) "\0"
	"f_firmware_addr=" MK_STR(IFX_CFG_FLASH_FIRMWARE_IMAGE_START_ADDR) "\0"
	"f_firmware_size=" MK_STR(IFX_CFG_FLASH_FIRMWARE_IMAGE_SIZE) "\0"
	"f_rootfs_addr=" MK_STR(IFX_CFG_FLASH_ROOTFS_IMAGE_START_ADDR) "\0"
	"f_rootfs_size=" MK_STR(IFX_CFG_FLASH_ROOTFS_IMAGE_SIZE) "\0"
	"f_rootfs_end=" MK_STR(IFX_CFG_FLASH_ROOTFS_IMAGE_START_ADDR) "\0" 
	"f_kernel_addr=" MK_STR(IFX_CFG_FLASH_KERNEL_IMAGE_START_ADDR) "\0"
	"kernel_addr=" MK_STR(IFX_CFG_FLASH_KERNEL_IMAGE_START_ADDR) "\0"
	"f_kernel_size=" MK_STR(IFX_CFG_FLASH_KERNEL_IMAGE_SIZE) "\0"
	"f_sysconfig_addr=" MK_STR(IFX_CFG_FLASH_SYSTEM_CFG_START_ADDR) "\0"
	"f_sysconfig_size=" MK_STR(IFX_CFG_FLASH_SYSTEM_CFG_SIZE) "\0"
	"f_ubootconfig_addr=" MK_STR(IFX_CFG_FLASH_UBOOT_CFG_START_ADDR) "\0"
	"f_ubootconfig_size=" MK_STR(IFX_CFG_FLASH_UBOOT_CFG_SIZE) "\0"
	"f_fwdiag_addr=" MK_STR(IFX_CFG_FLASH_FIRMWARE_DIAG_START_ADDR) "\0"
	"f_fwdiag_size=" MK_STR(IFX_CFG_FLASH_FIRMWARE_DIAG_SIZE) "\0"
#ifdef IFX_CONFIG_WIRELESS_IFX1350
	"f_voip_addr=" MK_STR(IFX_CFG_FLASH_VOIP_CFG_START_ADDR) "\0"
	"f_voip_size=" MK_STR(IFX_CFG_FLASH_VOIP_CFG_SIZE) "\0"
#endif
	"chipid=1.2\0"
	"boardid=112233\0"

