/* This file is added by Hareesh to support the aconfig background task management*/
#define CFG_ACONFIG
#include <common.h>
#ifdef CFG_ACONFIG

#define MAX_BACKGROUND_TASKS    16

static void (*bg_tasklist[MAX_BACKGROUND_TASKS])(void *);
static void *bg_args[MAX_BACKGROUND_TASKS];

void bg_init(void)
{
    memset(bg_tasklist,0,sizeof(bg_tasklist));
}

void bg_add(void (*func)(void *x),void *arg)
{
    int idx;

    for (idx = 0; idx < MAX_BACKGROUND_TASKS; idx++) {
        if (bg_tasklist[idx] == NULL) {
            bg_tasklist[idx] = func;
            bg_args[idx] = arg;
            return;
            }
        }
}

void bg_remove(void (*func)(void *))
{
    int idx;

    for (idx = 0; idx < MAX_BACKGROUND_TASKS; idx++) {
        if (bg_tasklist[idx] == func) break;
        }

    if (idx == MAX_BACKGROUND_TASKS) return;

    for (; idx < MAX_BACKGROUND_TASKS-1; idx++) {
        bg_tasklist[idx] = bg_tasklist[idx+1];
        bg_args[idx] = bg_args[idx+1];
        }

    bg_tasklist[idx] = NULL;
    bg_args[idx] = NULL;
}

void background(void)
{
    int idx;
    void (*func)(void *arg);

    for (idx = 0; idx < MAX_BACKGROUND_TASKS; idx++) {
        func = bg_tasklist[idx];
        if (func == NULL) break;
        (*func)(bg_args[idx]);
        }
}
#endif /* CFG_ACONFIG */

