#!/bin/sh 

if [ -e sysconfig.sh ]; then
	. sysconfig.sh
	. config.sh
	. model_config.sh
else
        echo "Application "$APPS_NAME" not configured"
	exit 0
fi                                                                                                                                       

display_info "----------------------------------------------------------------------"
display_info "-----------------------    build IFXAPIs   ---------------------------"
display_info "----------------------------------------------------------------------"

parse_args $@

if [ "$1" = "config_only" ] ;then
	exit 0
fi
if [ $BUILD_CLEAN -eq 1 ]; then
	make clean
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

if [ "$IFX_CONFIG_SNMPv3" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DIFX_CONFIG_SNMPv3"
fi

if [ "$IFX_CONFIG_SMASH_SNMP" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DIFX_CONFIG_SMASH_SNMP"
fi

#IFX_LDFLAGS="../lib/tmp/ifx_tr69.o ${IFX_LDFLAGS}"
#cp -f /home/TR69_lib/target_lib/tr69lib/*mips* ${BUILD_ROOTFS_DIR}lib/
IFXAPI_LDFLAGS="${IFX_LDFLAGS}"
if [ "$IFX_CONFIG_TR69" = "1" ]; then
	IFXAPI_LDFLAGS="${IFXAPI_LDFLAGS} -lProtoAdaptmips-linux -lObjAPImips-linux"
	cd "$TR69_SRC_DIR"
	./build_tr69_lib.sh $@
	ifx_error_check $? 
	cd -
fi

if [ "$IFX_CONFIG_OAM" = "1" ]; then
	IFXAPI_LDFLAGS="${IFXAPI_LDFLAGS} -loamapi "
fi

IFX_CFLAGS="${IFX_CFLAGS} -DCPU_${IFX_CONFIG_CPU} -I${UBOOT_SOURCE_DIR}include"

if [ "$IFX_CONFIG_TR69" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DTR69_DEFINED -DAMAZON "
fi


if [ "$IFX_CONFIG_DSL_CPE_API" = "1" ]; then
        IFX_CFLAGS="${IFX_CFLAGS} -DLINUX -I${USER_IFXSOURCE_DIR}dsl_api/drv_dsl_cpe_api/src/include -I${USER_IFXSOURCE_DIR}dsl_api/dsl_cpe_control/src -DDSL_CHANNELS_PER_LINE=1"
        if [ "$IFX_CONFIG_CPU" = "AMAZON_SE" -o "$IFX_CONFIG_CPU" = "DANUBE" ]; then
                #8111001:<IFTW-linje> integrated DSL API 3.16.3
                IFX_CFLAGS="${IFX_CFLAGS} -DINCLUDE_DSL_CPE_API_DANUBE -DIFX_CONFIG_DSL_CPE_API"
                #IFX_CFLAGS="${IFX_CFLAGS} -DINCLUDE_DSL_CPE_API_${IFX_CONFIG_CPU} -DIFX_CONFIG_DSL_CPE_API"
        fi

fi 

if [ "$IFX_CONFIG_WIRELESS" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DIFX_CONFIG_WIRELESS "
fi

if [ "$IFX_CONFIG_WIRELESS_TSC" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DIFX_CONFIG_TSC_WLAN -I${USER_IFXSOURCE_DIR}thomson-wlan-rel-2b/Lib/Source/H/ -I${USER_IFXSOURCE_DIR}thomson-wlan-rel-2b/Cli/Source/H/"
	# extract the thomson wlan object files here to include in libIFXAPIs.so
	#${IFX_AR} -x ${USER_IFXSOURCE_DIR}thomson-wlan-rel-2b/Lib/Debug/libmaxBaseLinux.a
	#${IFX_AR} -x ${LIBPATH}/libpcap.a
	IFXAPI_LDFLAGS="${IFXAPI_LDFLAGS} -L${USER_IFXSOURCE_DIR}thomson-wlan-rel-2b/Lib/Debug -lmaxBaseLinux_tsc -lpthread"
	#IFXAPI_LDFLAGS="${IFXAPI_LDFLAGS} ${USER_IFXSOURCE_DIR}thomson-wlan-rel-2b/Lib/Debug/libmaxBaseLinux.a"
	#IFXAPI_LDFLAGS="${IFXAPI_LDFLAGS} -L${USER_IFXSOURCE_DIR}thomson-wlan-rel-2b/Lib/Debug -lmaxBaseLinux"
fi

make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS} -DIFX_SMALL_FOOTPRINT -DIFX_DLOAD_LIBCRYPT" IFX_LDFLAGS="${IFX_LDFLAGS}" IFXAPI_LDFLAGS="${IFXAPI_LDFLAGS}" BUILD_TOOLS_DIR="${BUILD_TOOLS_DIR}" TSC_LIB="${USER_IFXSOURCE_DIR}thomson-wlan-rel-2b/Lib/Debug/libmaxBaseLinux.a" TOOLCHAIN_LIB_PATH="${LIBPATH}"
ifx_error_check $? 
${IFX_STRIP} --strip-unneeded ${IFX_APIS_DIR}lib/*
install -d ${BUILD_ROOTFS_DIR}lib/
cp -f ${IFX_APIS_DIR}lib/*.so ${BUILD_ROOTFS_DIR}lib/.
ifx_error_check $? 
#rm -f ${IFX_BINARY_DIR}IFXAPIs/include/*
#cp -f ${IFX_APIS_DIR}include/* ${IFX_BINARY_DIR}IFXAPIs/include
#rm -f ${IFX_BINARY_DIR}IFXAPIs/src/*.o
#cp -f ${IFX_APIS_DIR}src/*.o ${IFX_BINARY_DIR}IFXAPIs/src
