#!/bin/sh

if [ -e sysconfig.sh ]; then
	. sysconfig.sh
	. config.sh
	. model_config.sh
else
        echo "Application "$APPS_NAME" not configured"
	exit 0
fi                                                                                                                                       

display_info "----------------------------------------------------------------------"
display_info "-----------------------    build IFXAPIs   ---------------------------"
display_info "----------------------------------------------------------------------"

IFX_CC=gcc
IFX_AR=ar
IFX_LD=ld
IFX_CFLAGS="-g "
IFX_APIS_DIR=${PWD}/../

parse_args $@

if [ "$1" = "config_only" ] ;then
	exit 0
fi

if [ $BUILD_CLEAN -eq 1 ]; then
	make clean
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

IFX_CFLAGS="${IFX_CFLAGS} -DHOSTENV"

if [ ! -d "../lib_pc" ]; then
	mkdir ../lib_pc
fi

if [ "$IFX_CONFIG_SNMPv3" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DIFX_CONFIG_SNMPv3"
fi

if [ "$IFX_CONFIG_SMASH_SNMP" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DIFX_CONFIG_SMASH_SNMP"
fi

#IFXAPI_LDFLAGS="${IFX_LDFLAGS}"
if [ "$IFX_CONFIG_TR69" = "1" ]; then
	IFXAPI_LDFLAGS="${IFXAPI_LDFLAGS} -L $TR69_SRC_DIR/lib_pc/ -lProtoAdapt -lObjAPI"
	cd "$TR69_SRC_DIR"
	./build_tr69_lib_pc.sh $@
	cd -
fi

if [ "$IFX_CONFIG_OAM" = "1" ]; then
	IFXAPI_LDFLAGS="${IFXAPI_LDFLAGS} -L ../lib_pc/ -loamapi "
fi

IFX_CFLAGS="${IFX_CFLAGS} -DCPU_${IFX_CONFIG_CPU} -I${UBOOT_SOURCE_DIR}include"

if [ "$IFX_CONFIG_TR69" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DTR69_DEFINED -DAMAZON -DINCLUDE_DSL_CPE_API_DANUBE -DIFX_LOG_DEBUG "
fi
 
if [ "$IFX_CONFIG_DSL_CPE_API" = "1" ]; then
        IFX_CFLAGS="${IFX_CFLAGS} -DLINUX -I${USER_IFXSOURCE_DIR}dsl_api/drv_dsl_cpe_api/src/include -I${USER_IFXSOURCE_DIR}dsl_api/dsl_cpe_control/src -DDSL_CHANNELS_PER_LINE=1"
       if [ "$IFX_CONFIG_CPU" = "AMAZON_SE" -o "$IFX_CONFIG_CPU" = "DANUBE" ]; then
               IFX_CFLAGS="${IFX_CFLAGS} -DINCLUDE_DSL_CPE_API_${IFX_CONFIG_CPU} -DIFX_CONFIG_DSL_CPE_API"
       fi

fi 

if [ "$IFX_CONFIG_WIRELESS_TSC" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DIFX_CONFIG_TSC_WLAN -I${USER_IFXSOURCE_DIR}thomson-wlan-rel-2b/Lib/Source/H/ -I${USER_IFXSOURCE_DIR}thomson-wlan-rel-2b/Cli/Source/H/"
fi

#make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS} -g -I. -I${PWD}/../include -DLINUX " IFX_LDFLAGS="${IFX_LDFLAGS}" IFXAPI_LDFLAGS="${IFXAPI_LDFLAGS}" BUILD_TOOLS_DIR="${BUILD_TOOLS_DIR}" HOST_PLATFORM="x86"
make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS} -I${PWD}/../include -I. " IFXAPI_LDFLAGS="${IFXAPI_LDFLAGS}" BUILD_TOOLS_DIR="${BUILD_TOOLS_DIR}" HOST_PLATFORM="x86"

ifx_error_check $? 

