#!/bin/sh
APPS_NAME="CLI"
if [ -e sysconfig.sh ]; then
	. sysconfig.sh
	. config.sh
	. model_config.sh
else
        echo "Application "$APPS_NAME" not configured"
        exit 0
fi                                                                                                                                       

display_info "----------------------------------------------------------------------"
display_info "---------------------------  build CLI  ------------------------------"
display_info "----------------------------------------------------------------------"

parse_args $@

if [ "$1" = "config_only" ] ;then
	exit 0
fi

# 607231:fchang.removed
# if [ "$1"="-configure" -o "$1"="-clean" ] ; then
#  make clean 
# fi

if [ "$IFX_CONFIG_DSL_CPE_API" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DLINUX -I${USER_IFXSOURCE_DIR}dsl_api/drv_dsl_cpe_api/src/include -I${USER_IFXSOURCE_DIR}dsl_api/dsl_cpe_control/src -DDSL_CHANNELS_PER_LINE=1"
	if [ "$IFX_CONFIG_CPU" = "AMAZON_SE" -o "$IFX_CONFIG_CPU" = "DANUBE" ]; then
		#IFX_CFLAGS="${IFX_CFLAGS} -DINCLUDE_DSL_CPE_API_${IFX_CONFIG_CPU} -DIFX_CONFIG_DSL_CPE_API"
		IFX_CFLAGS="${IFX_CFLAGS} -DINCLUDE_DSL_CPE_API_DANUBE -DIFX_CONFIG_DSL_CPE_API"
	fi
	
fi


# 607231:fchang.added
if [ $BUILD_CLEAN -eq 1 ]; then
        make clean
        [ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

#make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS} -Os" IFX_LDFLAGS="${IFX_LDFLAGS}"  -C ../IFXAPIs/src ifx_common.o
#ifx_error_check $? 

make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS} -Os" IFX_LDFLAGS="${IFX_LDFLAGS}" all
ifx_error_check $? 

${IFX_STRIP} -R.note -R.comment cli_fe
${IFX_STRIP} -R.note -R.comment cli_be
ifx_error_check $? 

cp cli_fe ${BUILD_ROOTFS_DIR}usr/sbin
cp cli_be ${BUILD_ROOTFS_DIR}usr/sbin
