#!/bin/sh
APPS_NAME="ifx_web_server"
if [ -e sysconfig.sh ]; then
	. sysconfig.sh
	. config.sh
	. model_config.sh
else
        echo "Application "$APPS_NAME" not configured"
        exit 0
fi                                                                                                                                       

#CONFIG_FULL_PACKAGE=y

display_info "----------------------------------------------------------------------"
display_info "-----------------------      build ifx_httpd_server  ---------------"
display_info "----------------------------------------------------------------------"

parse_args $@

if [ "$1" = "config_only" ] ;then
	exit 0
fi

if [ $BUILD_CLEAN -eq 1 ] ; then
	make clean 
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

IFX_CFLAGS="${IFX_CFLAGS} -I../../../u-boot/include -DCPU_${IFX_CONFIG_CPU}"

if [ "$IFX_CONFIG_DSL_CPE_API" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DIFX_CONFIG_DSL_CPE_API -DLINUX -I${USER_IFXSOURCE_DIR}dsl_api/drv_dsl_cpe_api/src/include -I${USER_IFXSOURCE_DIR}dsl_api/dsl_cpe_control/src "
	if [ "$IFX_CONFIG_CPU" = "AMAZON_SE" -o "$IFX_CONFIG_CPU" = "DANUBE" ]; then
		IFX_CFLAGS="${IFX_CFLAGS} -DINCLUDE_DSL_CPE_API_DANUBE"
	fi
fi

#609041:jelly
if [ "$IFX_CONFIG_SSH_SERVER" != "" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DIFX_CONFIG_SSH_SERVER"
fi

if [ "${IFX_CONFIG_FLASH_TYPE}" == "SPI" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DSPI_SUPPORT"
fi


#make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS} -Os" IFX_LDFLAGS="${IFX_LDFLAGS}"  -C ../IFXAPIs/src ifx_common.o
#ifx_error_check $? 

if [ -n "$IFX_CONFIG_VOIP" -a "$IFX_CONFIG_VOIP" = "1" ]; then 
# 509151:jelly:start
if [ "$CONFIG_FULL_PACKAGE" == "y" ]; then
display_info "----------------------------------------------------------------------"
display_info "-----------------------      build libvoip.so  ---------------"
display_info "----------------------------------------------------------------------"

export PRODUCT="$IFX_CONFIG_CPU"
export IFX_PRODUCT_ROOT=${USER_IFXSOURCE_DIR}/gateway-sip
cd ${USER_IFXSOURCE_DIR}/gateway-sip/ifx_mips/source/user/opensource/ifx_httpd/
./build_mips.sh $@
ifx_error_check $?
if [ $? -ne 0 ]; then
 display_error "Building VOIP Libraries failed!"
 exit 1
fi
 cd -
cp ${USER_IFXSOURCE_DIR}/gateway-sip/ifx_mips/source/user/opensource/ifx_httpd/voip_httpd.o  .
else
cp ${USER_IFXSOURCE_DIR}/gateway-sip/ifx_mips/source/user/opensource/ifx_httpd/voip_httpd.o  .
fi
fi

make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS} -Os" IFX_LDFLAGS="${IFX_LDFLAGS}" all
ifx_error_check $? 

${IFX_STRIP} libifx_httpd.so
ifx_error_check $? 

cp -af libifx_httpd.so ${BUILD_ROOTFS_DIR}lib/
cp -af web ${BUILD_ROOTFS_DIR}usr/
if [ "$IFX_CONFIG_INNOVE" = "1" ]; then
	cp -af Innova/* ${BUILD_ROOTFS_DIR}usr/web/
fi
if [ "$IFX_CONFIG_GVT" = "1" ]; then
	cp -af GVT/* ${BUILD_ROOTFS_DIR}usr/web/
fi
if [ "$IFX_CONFIG_CWPANAMA" = "1" ]; then
	cp -af CWP/* ${BUILD_ROOTFS_DIR}usr/web/
fi
if [ "$IFX_CONFIG_PORTUGESE" = "1" ]; then
	cp -af Portugese/* ${BUILD_ROOTFS_DIR}usr/web/
fi
if [ "$IFX_CONFIG_DIGITEL" = "1" ]; then
	cp -af Digitel/* ${BUILD_ROOTFS_DIR}usr/web/
fi
if [ "$IFX_CONFIG_AZTECH_WEBPAGE" = "1" ]; then
	cp -af Aztech_WebPage/* ${BUILD_ROOTFS_DIR}usr/web/
fi
if [ "$IFX_CONFIG_ALLNET" = "1" ]; then
	cp -af Allnet/* ${BUILD_ROOTFS_DIR}usr/web/
fi
if [ "$IFX_CONFIG_AMPER" = "1" ]; then
	cp -af Amper/* ${BUILD_ROOTFS_DIR}usr/web/
fi
if [ "$IFX_CONFIG_WILTEL" = "1" ]; then
        cp -af Wiltel_WebPage/* ${BUILD_ROOTFS_DIR}usr/web/
fi
if [ "$IFX_CONFIG_TNN" = "1" ]; then
        cp -af TNN_Paltel/* ${BUILD_ROOTFS_DIR}usr/web/
fi
if [ "$IFX_CONFIG_MSO" = "1" ]; then
        cp -af MSO/* ${BUILD_ROOTFS_DIR}usr/web/
fi
if [ "$IFX_CONFIG_BLUECOM" = "1" ]; then
        cp -af BLUECOM/* ${BUILD_ROOTFS_DIR}usr/web/
fi
if [ "$IFX_CONFIG_HARADA" = "1" ]; then
        cp -af Harada/* ${BUILD_ROOTFS_DIR}usr/web/
fi

if [ "$IFX_CONFIG_2ND_GUI" = "1" ]; then
        cp -af 2ndGUI/* ${BUILD_ROOTFS_DIR}usr/web/
fi

if [ -n "$IFX_CONFIG_VOIP" -a "$IFX_CONFIG_VOIP" = "1" ]; then 
	cp -af ${USER_IFXSOURCE_DIR}/gateway-sip/cm/lib/${IFX_CONFIG_CPU}/libcm.so ${BUILD_ROOTFS_DIR}lib/
	cp -f ${USER_IFXSOURCE_DIR}/gateway-sip/ifx_mips/web/voip* ${BUILD_ROOTFS_DIR}usr/web/.
fi

if [ "$IFX_CONFIG_CLI" = "1" ]; then
	cp -af cli ${BUILD_ROOTFS_DIR}usr/
fi
