#!/bin/sh
APPS_NAME="oamd"
if [ -e sysconfig.sh ]; then
	. sysconfig.sh
	. config.sh
	. model_config.sh
else
        echo "Application "$APPS_NAME" not configured"
        exit 0
fi                                                                                                                                       

display_info "----------------------------------------------------------------------"
display_info "---------------------------     build oamd  --------------------------"
display_info "----------------------------------------------------------------------"

#CONFIG_FULL_PACKAGE=y
if [ "$CONFIG_FULL_PACKAGE" == "y" ]; then

parse_args $@

if [ "$1" = "config_only" ] ;then
	exit 0
fi

if [ $BUILD_CLEAN -eq 1 ]; then
	make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS}" IFX_LDFLAGS="${IFX_LDFLAGS}" IFX_APIS_DIR=${IFX_APIS_DIR} clean
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

if [ "$IFX_CONFIG_OAM_FULL" = "1" ]; then
	EXTRA_CONFIG=""
else
	EXTRA_CONFIG="IFX_2MB_OAM_PKG=1"
fi

	make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS}" IFX_LDFLAGS="${IFX_LDFLAGS}" IFX_APIS_DIR=${IFX_APIS_DIR}  ${EXTRA_CONFIG} all
ifx_error_check $? 

make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS}" IFX_LDFLAGS="${IFX_LDFLAGS}" STRIP=${IFX_STRIP} IFX_APIS_DIR=${IFX_APIS_DIR} ifxinstall
ifx_error_check $? 

install -d ${BUILD_ROOTFS_DIR}lib/
install -d ${BUILD_ROOTFS_DIR}usr/bin/
cp -f oamd ${BUILD_ROOTFS_DIR}usr/bin/.
cp -f liboamapi.so ${BUILD_ROOTFS_DIR}lib/.
cp -f oamctl ${BUILD_ROOTFS_DIR}usr/bin/.
ifx_error_check $? 

#cp -af oamd ${IFX_BINARY_DIR}usr/bin/.
#cp -af oamctl ${IFX_BINARY_DIR}usr/bin/.

else
  install -d ${BUILD_ROOTFS_DIR}lib/
  install -d ${BUILD_ROOTFS_DIR}usr/bin/
  cp -f oamd ${BUILD_ROOTFS_DIR}usr/bin/.
  cp -f liboamapi.so ${BUILD_ROOTFS_DIR}lib/.
  cp -f oamctl ${BUILD_ROOTFS_DIR}usr/bin/.
fi
