#!/bin/sh
APPS_NAME="oamd"
if [ -e sysconfig.sh ]; then
	. sysconfig.sh
	. config.sh
	. model_config.sh
else
        echo "Application "$APPS_NAME" not configured"
        exit 0
fi                                                                                                                                       

display_info "----------------------------------------------------------------------"
display_info "---------------------------     build oamd  --------------------------"
display_info "----------------------------------------------------------------------"


CONFIG_FULL_PACKAGE=y
if [ "$CONFIG_FULL_PACKAGE" == "y" ]; then

parse_args $@

#cp -f Makefile_pc Makefile

if [ "$1" = "config_only" ] ;then
	exit 0
fi

IFX_CC=gcc
IFX_AR=ar
IFX_AS=as
IFX_LD=ld
IFX_NM=nm
IFX_STRIP=
IFX_RANLIB=ranlib
IFX_CXX=g++
IFX_CPP=cpp
IFX_OBJCOPY=objcopy
IFX_OBJDUMP=objdump
IFX_HOSTCC=gcc
IFX_LDFLAGS=-L.
IFX_CFLAGS=

if [ $BUILD_CLEAN -eq 1 ]; then
	make -f Makefile_pc AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS}" IFX_LDFLAGS="${IFX_LDFLAGS}" IFX_APIS_DIR=${IFX_APIS_DIR} clean
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

if [ "$IFX_CONFIG_OAM_FULL" = "1" ]; then
	EXTRA_CONFIG=""
else
	EXTRA_CONFIG="IFX_2MB_OAM_PKG=1"
fi

	make -f Makefile_pc AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS}" IFX_LDFLAGS="${IFX_LDFLAGS}" IFX_APIS_DIR=${IFX_APIS_DIR}  ${EXTRA_CONFIG} all

	install -d ${IFX_APIS_DIR}/lib_pc
	cp -f ./liboamapi.so ${IFX_APIS_DIR}/lib_pc/.
ifx_error_check $? 

fi
