#!/bin/sh
#TOPDIR=`pwd`/../../../../
#. ${TOPDIR}tools/build_tools/Path.sh
#tc.chen read configuration 
#. ${TOPDIR}tools/build_tools/config.sh
APPS_NAME="devm"

echo "----------------------------------------------------------------------"
echo "---------------------  build IFX TR69 Application --------------------"
echo "----------------------------------------------------------------------"

#change the following variables/flags to compile TR69 application

#Flags from Path.sh 
IFX_CFLAGS="-Os -mips32 -mtune=4kc -I/vobs/comac_amazon_lxdb1.1/source/user/ifx/IFXAPIs/include"
BUILD_ROOTFS_DIR=

#Flags from config.sh
IFX_CONFIG_TR69=1			#To build TR69 or not
IFX_CONFIG_TR69_DEVICE=0		#To build TR69 for a CPE (device)
IFX_CONFIG_TR111_STUN=0 		#To include STUN related code
IFX_CONFIG_TR111_DEVICE_ASSOCIATION=0	#To include IGD-Device Association code
IFX_CONFIG_TR104=0	                #To include TR104 support to IGD
IFX_CONFIG_LMP=1	                #To include TR64 support to IGD
IFX_TR64_TEST_ADAPT=1

#Flags from command line
STATIC=0		#Compile the libraries as static or dynamic
DEBUG=1			#Compile with debug info or not - Required to work with debugging tools
TR69DEBUG=1		#Runtime debug log messages of TR69 enabled
STANDALONE=1		#Compile standalone or across vobs
#TARGET=mips-linux	#For Target Compilation
TARGET=                 #For Host compilation
TR69SYSLOG=		#To redirect the log to the syslog daemon
TR69APPL=1		#To build as daemon or application
SSL=MATRIXSSL		#To build with Matrixtunnel support option = MATRIXSSL or OPENSSL

#End of compilation flags


CONFIG_TR69=y

if [ $IFX_CONFIG_TR69 -a "$IFX_CONFIG_TR69" = "1" ]; then

parse_args()
{
    echo parse_args
    echo $0 $1 $2 $3 $4 $5
    BUILD_CLEAN=0
    BUILD_CONFIGURE=0
    while [ $# -ge 1 ]; do
        case $1 in
        -clean)
            echo clean
            BUILD_CLEAN=1;;
        -configure)
            echo configure
            BUILD_CONFIGURE=1;;
        config_only)
            ;;
        *) build_help ;;
        esac
        shift
    done
}

parse_args $@


if [ "$1" = "config_only" ] ;then
	exit 0
fi

if [ ! -d src ] ; then
CUSTOMER_PKG=1
else
CUSTOMER_PKG=0
fi


if [ $IFX_CONFIG_TR69_DEVICE -eq 1 ]; then
IFX_CONFIG_TR111_STUN=1 		#To include STUN related code
IFX_CONFIG_TR111_DEVICE_ASSOCIATION=1	#To include IGD-Device Association code
IFX_CONFIG_TR104=0	                #To include TR104 support to IGD
else
if [ $STANDALONE -eq 1 ]; then
IFX_CONFIG_TR104=0	                #To include TR104 support to IGD
else
IFX_CONFIG_TR104=0	                #To include TR104 support to IGD
fi
fi


if [ $BUILD_CLEAN -eq 1 ]; then
	make STATIC=${STATIC} DEBUG=${DEBUG} TR69DEBUG=${TR69DEBUG} STANDALONE=${STANDALONE} TARGET=${TARGET} TR69SYSLOG=${TR69SYSLOG} TR69APPL=${TR69APPL} SSL=${SSL} IFX_CONFIG_TR69_DEVICE=${IFX_CONFIG_TR69_DEVICE} IFX_CONFIG_TR111_STUN=${IFX_CONFIG_TR111_STUN} IFX_TR64_TEST_ADAPT=${IFX_TR64_TEST_ADAPT} IFX_CONFIG_TR111_DEVICE_ASSOCIATION=${IFX_CONFIG_TR111_DEVICE_ASSOCIATION} IFX_CONFIG_TR104=${IFX_CONFIG_TR104} IFX_CONFIG_LMP=${IFX_CONFIG_LMP} CUSTOMER_PKG=${CUSTOMER_PKG} IFX_CFLAGS="${IFX_CFLAGS}" BUILD_ROOTFS_DIR=${BUILD_ROOTFS_DIR} clean -C .
	rm -f ./../bin/tr69_db.txt
	rm -f ./../bin/TR064_DB.txt
	rm -f ./../bin/rc.conf
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi
	make STATIC=${STATIC} DEBUG=${DEBUG} TR69DEBUG=${TR69DEBUG} STANDALONE=${STANDALONE} TARGET=${TARGET} TR69SYSLOG=${TR69SYSLOG} TR69APPL=${TR69APPL} SSL=${SSL} IFX_CONFIG_TR69_DEVICE=${IFX_CONFIG_TR69_DEVICE} IFX_CONFIG_TR111_STUN=${IFX_CONFIG_TR111_STUN} IFX_TR64_TEST_ADAPT=${IFX_TR64_TEST_ADAPT} IFX_CONFIG_TR111_DEVICE_ASSOCIATION=${IFX_CONFIG_TR111_DEVICE_ASSOCIATION} IFX_CONFIG_TR104=${IFX_CONFIG_TR104} IFX_CONFIG_LMP=${IFX_CONFIG_LMP} CUSTOMER_PKG=${CUSTOMER_PKG} IFX_CFLAGS="${IFX_CFLAGS}" BUILD_ROOTFS_DIR=${BUILD_ROOTFS_DIR} all -C .
	cp -f ./../../../cwmp/bin/tr69_db.txt ./../bin/
	cp -f ./../../../cwmp/bin/TR064_DB.txt ./../bin/
	cp -f ./../../../cwmp/bin/rc.conf ./../bin/
else

	echo "TR69 is not enabled !!"
fi

