#!/bin/sh
APPS_NAME="devm"
if [ -e sysconfig.sh ]; then
	. sysconfig.sh
	. config.sh
	. model_config.sh
else
        echo "Application "$APPS_NAME" not configured"
        exit 0
fi

display_info "----------------------------------------------------------------------"
display_info "---------------------  build IFX TR69 Application --------------------"
display_info "----------------------------------------------------------------------"

CONFIG_TR69=y

if [ $IFX_CONFIG_TR69 -a "$IFX_CONFIG_TR69" = "1" ]; then

parse_args $@


if [ "$1" = "config_only" ] ;then
	exit 0
fi

if [ ! -d cwmp/src ] ; then
TR69_SOURCE=0
else
TR69_SOURCE=1
fi

if [ ! -f LMP/tr64/src/IFX_TR64_DescGen.c ] ; then
TR64_SOURCE=0
else
TR64_SOURCE=1
fi


#Flags from command line
STATIC=0		#Compile the libraries as static or dynamic
DEBUG=0			#Compile with debug info or not - Required to work with debugging tools
#if [ "$IFX_CONFIG_WIRELESS_TSC" = "1" ]; then
TR69DEBUG=1		#Runtime debug log messages of TR69 enabled
#else
#TR69DEBUG=0		#Runtime debug log messages of TR69 disabled
#fi

STANDALONE=0		#Compile standalone or across vobs
TARGET=mips-linux	#For Target Compilation
#TARGET=                 #For Host compilation
TR69SYSLOG=		#To redirect the log to the syslog daemon
TR69APPL=1		#To build as daemon or application
if [ $CONFIG_MATRIX -a "$CONFIG_MATRIX" = "1" ]; then
SSL=MATRIXSSL           #To build with Matrixtunnel support option = MATRIXSSL or OPENSSL
else
SSL=OPENSSL           #To build with Matrixtunnel support option = MATRIXSSL or OPENSSL
fi

if [ "${IFX_CONFIG_FLASH_TYPE}" == "SPI" ]; then
	IFX_CFLAGS+="${IFX_CFLAGS} -DSPI_SUPPORT"
fi

if [ "$IFX_CONFIG_DSL_CPE_API" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DLINUX -I${USER_IFXSOURCE_DIR}dsl_api/drv_dsl_cpe_api/src/include -I${USER_IFXSOURCE_DIR}dsl_api/dsl_cpe_control/src -DDSL_CHANNELS_PER_LINE=1"
	if [ "$IFX_CONFIG_CPU" = "AMAZON_SE" -o "$IFX_CONFIG_CPU" = "DANUBE" ]; then
# Fixed by Subbi
#		IFX_CFLAGS="${IFX_CFLAGS} -DINCLUDE_DSL_CPE_API_${IFX_CONFIG_CPU} -DIFX_CONFIG_DSL_CPE_API"
		IFX_CFLAGS="${IFX_CFLAGS} -DINCLUDE_DSL_CPE_API_DANUBE -DIFX_CONFIG_DSL_CPE_API -DINCLUDE_DSL_ADSL_MIB"
	fi
	
fi

if [ $BUILD_CLEAN -eq 1 ]; then
        #make IFX_CONFIG_FLASH_SIZE=${IFX_CONFIG_FLASH_SIZE} STATIC=${STATIC} DEBUG=${DEBUG} TR69DEBUG=${TR69DEBUG} STANDALONE=${STANDALONE} TARGET=${TARGET} TR69SYSLOG=${TR69SYSLOG} TR69APPL=${TR69APPL} SSL=${SSL} IFX_CONFIG_TR69=${IFX_CONFIG_TR69} IFX_CONFIG_TR69_IGD=${IFX_CONFIG_TR69_IGD} IFX_CONFIG_TR69_WIFILAN=${IFX_CONFIG_TR69_WIFILAN} IFX_CONFIG_TR69_USBLAN=${IFX_CONFIG_TR69_USBLAN} IFX_CONFIG_TR69_ETHERNETLAN=${IFX_CONFIG_TR69_ETHERNETLAN} IFX_CONFIG_TR69_ADSLWAN=${IFX_CONFIG_TR69_ADSLWAN} IFX_CONFIG_TR69_TIME=${IFX_CONFIG_TR69_TIME} IFX_CONFIG_TR69_IPPING=${IFX_CONFIG_TR69_IPPING} IFX_CONFIG_TR69_ATMLOOPBACK=${IFX_CONFIG_TR69_ATMLOOPBACK} IFX_CONFIG_TR69_DSLDIAGNOSTICS=${IFX_CONFIG_TR69_DSLDIAGNOSTICS} IFX_CONFIG_TR111_STUN=${IFX_CONFIG_TR111_STUN} IFX_CONFIG_TR111_DEVICE_ASSOCIATION=${IFX_CONFIG_TR111_DEVICE_ASSOCIATION} IFX_CONFIG_LMP=${IFX_CONFIG_LMP} IFX_CONFIG_UPNP=${IFX_CONFIG_UPNP} IFX_CONFIG_TR64=${IFX_CONFIG_TR64} IFX_CONFIG_TR69_DEVICE=${IFX_CONFIG_TR69_DEVICE} IFX_CONFIG_TR69_DEVICE_LAN=${IFX_CONFIG_TR69_DEVICE_LAN} IFX_CONFIG_TR69_SSL=${IFX_CONFIG_TR69_SSL} CONFIG_MATRIX=${CONFIG_MATRIX} TR69_SOURCE=${TR69_SOURCE} TR64_SOURCE=${TR64_SOURCE} IFX_CFLAGS="${IFX_CFLAGS}" BUILD_ROOTFS_DIR=${BUILD_ROOTFS_DIR} IFX_ROOTFS_DIR=${IFX_ROOTFS_DIR} devm_clean -C cwmp
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

# Create the required TR69 directory structure
#if [ ! -h ${BUILD_ROOTFS_DIR}etc/tr69 ]; then
#    ln -s ../ramdisk/etc/tr69 ${BUILD_ROOTFS_DIR}etc/tr69
#fi

if [ ! -d ${BUILD_ROOTFS_DIR}ramdisk_copy ]; then
    mkdir ${BUILD_ROOTFS_DIR}ramdisk_copy
	if [ ! -d ${BUILD_ROOTFS_DIR}ramdisk_copy/etc ]; then
    	mkdir ${BUILD_ROOTFS_DIR}ramdisk_copy/etc
		if [ ! -d ${BUILD_ROOTFS_DIR}ramdisk_copy/etc/tr69 ]; then
    		mkdir ${BUILD_ROOTFS_DIR}ramdisk_copy/etc/tr69
		fi
	fi
fi

        #make IFX_CONFIG_FLASH_SIZE=${IFX_CONFIG_FLASH_SIZE} STATIC=${STATIC} DEBUG=${DEBUG} TR69DEBUG=${TR69DEBUG} STANDALONE=${STANDALONE} TARGET=${TARGET} TR69SYSLOG=${TR69SYSLOG} TR69APPL=${TR69APPL} SSL=${SSL} IFX_CONFIG_TR69=${IFX_CONFIG_TR69} IFX_CONFIG_TR69_IGD=${IFX_CONFIG_TR69_IGD} IFX_CONFIG_TR69_WIFILAN=${IFX_CONFIG_TR69_WIFILAN} IFX_CONFIG_TR69_USBLAN=${IFX_CONFIG_TR69_USBLAN} IFX_CONFIG_TR69_ETHERNETLAN=${IFX_CONFIG_TR69_ETHERNETLAN} IFX_CONFIG_TR69_ADSLWAN=${IFX_CONFIG_TR69_ADSLWAN} IFX_CONFIG_TR69_TIME=${IFX_CONFIG_TR69_TIME} IFX_CONFIG_TR69_IPPING=${IFX_CONFIG_TR69_IPPING} IFX_CONFIG_TR69_ATMLOOPBACK=${IFX_CONFIG_TR69_ATMLOOPBACK} IFX_CONFIG_TR69_DSLDIAGNOSTICS=${IFX_CONFIG_TR69_DSLDIAGNOSTICS} IFX_CONFIG_TR111_STUN=${IFX_CONFIG_TR111_STUN} IFX_CONFIG_TR111_DEVICE_ASSOCIATION=${IFX_CONFIG_TR111_DEVICE_ASSOCIATION} IFX_CONFIG_LMP=${IFX_CONFIG_LMP} IFX_CONFIG_UPNP=${IFX_CONFIG_UPNP} IFX_CONFIG_TR64=${IFX_CONFIG_TR64} IFX_CONFIG_TR69_DEVICE=${IFX_CONFIG_TR69_DEVICE} IFX_CONFIG_TR69_DEVICE_LAN=${IFX_CONFIG_TR69_DEVICE_LAN} IFX_CONFIG_TR69_SSL=${IFX_CONFIG_TR69_SSL} CONFIG_MATRIX=${CONFIG_MATRIX} TR69_SOURCE=${TR69_SOURCE} TR64_SOURCE=${TR64_SOURCE} IFX_CFLAGS="${IFX_CFLAGS}" BUILD_ROOTFS_DIR=${BUILD_ROOTFS_DIR} IFX_ROOTFS_DIR=${IFX_ROOTFS_DIR} devm_clean devm -C cwmp

ifx_error_check $? 

install -d ${BUILD_ROOTFS_DIR}lib/
install -d ${BUILD_ROOTFS_DIR}usr/sbin/
install -d ${BUILD_ROOTFS_DIR}etc/tr69/
install -d ${BUILD_ROOTFS_DIR}ramdisk_copy/etc/tr69/

	cp -f cwmp/bin/devm ${BUILD_ROOTFS_DIR}usr/sbin/.
	cp -f cwmp/bin/devmapp ${BUILD_ROOTFS_DIR}usr/sbin/.
	cp -f cwmp/bin/libCommonmips-linux.so ${BUILD_ROOTFS_DIR}lib
	cp -f cwmp/bin/libProtoAPImips-linux.so ${BUILD_ROOTFS_DIR}lib
	cp -f cwmp/bin/libProtoAdaptmips-linux.so ${BUILD_ROOTFS_DIR}lib
	cp -f cwmp/bin/libObjAPImips-linux.so ${BUILD_ROOTFS_DIR}lib
if [ "$IFX_CONFIG_TR111_STUN" = "1" ]; then
	cp -f cwmp/bin/libifxstun.so ${BUILD_ROOTFS_DIR}lib
fi
	cp -f cwmp/bin/tr69_db.txt ${BUILD_ROOTFS_DIR}etc/tr69
	cp -f cwmp/bin/devm.conf ${BUILD_ROOTFS_DIR}etc/tr69
if [ "$IFX_CONFIG_LMP" = "1" ]; then
	cp -f cwmp/bin/TR064_DB.txt ${BUILD_ROOTFS_DIR}etc/tr69
fi
if [ "$SSL" = "OPENSSL" ]; then
	cp -f cwmp/bin/stunnel.conf ${BUILD_ROOTFS_DIR}ramdisk_copy/etc/tr69
	cp -f cwmp/bin/stunnel.pem ${BUILD_ROOTFS_DIR}ramdisk_copy/etc/tr69
fi

if [ "$SSL" = "MATRIXSSL" ]; then
        if [ -a cwmp/bin/CAcertSrv.pem ]; then
                cp -f cwmp/bin/CAcertSrv.pem ${BUILD_ROOTFS_DIR}ramdisk_copy/etc/tr69
        fi
fi


ifx_error_check $? 

else

	display_error "TR69 is not enabled !!"
fi
