#!/bin/sh

if [ -e sysconfig.sh ]; then
	. sysconfig.sh
	. config.sh
	. model_config.sh
else
        echo "Application "$APPS_NAME" not configured"
        exit 0
fi                                                                                                                                       
./site_prep.sh


display_info "----------------------------------------------------------------------"
display_info "---------------------  build IFX TR69 Basic Libraries  ---------------"
display_info "----------------------------------------------------------------------"

CONFIG_TR69=y

if [ $IFX_CONFIG_TR69 -a "$IFX_CONFIG_TR69" = "1" ]; then

parse_args $@

if [ "$1" = "config_only" ] ;then
	exit 0
fi

if [ "$IFX_CONFIG_DSL_CPE_API" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DLINUX -I${USER_IFXSOURCE_DIR}dsl_api/drv_dsl_cpe_api/src/include -I${USER_IFXSOURCE_DIR}dsl_api/dsl_cpe_control/src -DDSL_CHANNELS_PER_LINE=1"
	if [ "$IFX_CONFIG_CPU" = "AMAZON_SE" -o "$IFX_CONFIG_CPU" = "DANUBE" ]; then
		IFX_CFLAGS="${IFX_CFLAGS} -DINCLUDE_DSL_CPE_API_DANUBE -DIFX_CONFIG_DSL_CPE_API"
	fi
	
fi

if [ $BUILD_CLEAN -eq 1 ]; then
	make IFX_CONFIG_FLASH_SIZE=${IFX_CONFIG_FLASH_SIZE} STATIC=0 DEBUG=0 TR69DEBUG=0 STANDALONE=0 TARGET=mips-linux TR69SYSLOG= TR69APPL=0 SSL=${SSL} IFX_CONFIG_TR69=${IFX_CONFIG_TR69} IFX_CONFIG_TR69_IGD=${IFX_CONFIG_TR69_IGD} IFX_CONFIG_TR69_WIFILAN=${IFX_CONFIG_TR69_WIFILAN} IFX_CONFIG_TR69_USBLAN=${IFX_CONFIG_TR69_USBLAN} IFX_CONFIG_TR69_ETHERNETLAN=${IFX_CONFIG_TR69_ETHERNETLAN} IFX_CONFIG_TR69_ADSLWAN=${IFX_CONFIG_TR69_ADSLWAN} IFX_CONFIG_TR69_TIME=${IFX_CONFIG_TR69_TIME} IFX_CONFIG_TR69_IPPING=${IFX_CONFIG_TR69_IPPING} IFX_CONFIG_TR69_ATMLOOPBACK=${IFX_CONFIG_TR69_ATMLOOPBACK} IFX_CONFIG_TR69_DSLDIAGNOSTICS=${IFX_CONFIG_TR69_DSLDIAGNOSTICS} IFX_CONFIG_TR111_STUN=${IFX_CONFIG_TR111_STUN} IFX_CONFIG_TR111_DEVICE_ASSOCIATION=${IFX_CONFIG_TR111_DEVICE_ASSOCIATION} IFX_CONFIG_LMP=${IFX_CONFIG_LMP} IFX_CONFIG_UPNP=${IFX_CONFIG_UPNP} IFX_CONFIG_TR64=${IFX_CONFIG_TR64} IFX_CONFIG_TR69_DEVICE=${IFX_CONFIG_TR69_DEVICE} IFX_CONFIG_TR69_DEVICE_LAN=${IFX_CONFIG_TR69_DEVICE_LAN} IFX_CONFIG_TR69_SSL=${IFX_CONFIG_TR69_SSL} CONFIG_MATRIX=${CONFIG_MATRIX} TR69_SOURCE=${TR69_SOURCE} TR64_SOURCE=${TR64_SOURCE} IFX_CFLAGS="${IFX_CFLAGS}" BUILD_ROOTFS_DIR=${BUILD_ROOTFS_DIR} IFX_ROOTFS_DIR=${IFX_ROOTFS_DIR} clean -C ./API -f Makefile.amz
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi
	make IFX_CONFIG_FLASH_SIZE=${IFX_CONFIG_FLASH_SIZE} STATIC=0 DEBUG=0 TR69DEBUG=0 STANDALONE=0 TARGET=mips-linux TR69SYSLOG= TR69APPL=0 SSL=${SSL} IFX_CONFIG_TR69=${IFX_CONFIG_TR69} IFX_CONFIG_TR69_IGD=${IFX_CONFIG_TR69_IGD} IFX_CONFIG_TR69_WIFILAN=${IFX_CONFIG_TR69_WIFILAN} IFX_CONFIG_TR69_USBLAN=${IFX_CONFIG_TR69_USBLAN} IFX_CONFIG_TR69_ETHERNETLAN=${IFX_CONFIG_TR69_ETHERNETLAN} IFX_CONFIG_TR69_ADSLWAN=${IFX_CONFIG_TR69_ADSLWAN} IFX_CONFIG_TR69_TIME=${IFX_CONFIG_TR69_TIME} IFX_CONFIG_TR69_IPPING=${IFX_CONFIG_TR69_IPPING} IFX_CONFIG_TR69_ATMLOOPBACK=${IFX_CONFIG_TR69_ATMLOOPBACK} IFX_CONFIG_TR69_DSLDIAGNOSTICS=${IFX_CONFIG_TR69_DSLDIAGNOSTICS} IFX_CONFIG_TR111_STUN=${IFX_CONFIG_TR111_STUN} IFX_CONFIG_TR111_DEVICE_ASSOCIATION=${IFX_CONFIG_TR111_DEVICE_ASSOCIATION} IFX_CONFIG_LMP=${IFX_CONFIG_LMP} IFX_CONFIG_UPNP=${IFX_CONFIG_UPNP} IFX_CONFIG_TR64=${IFX_CONFIG_TR64} IFX_CONFIG_TR69_DEVICE=${IFX_CONFIG_TR69_DEVICE} IFX_CONFIG_TR69_DEVICE_LAN=${IFX_CONFIG_TR69_DEVICE_LAN} IFX_CONFIG_TR69_SSL=${IFX_CONFIG_TR69_SSL} CONFIG_MATRIX=${CONFIG_MATRIX} TR69_SOURCE=${TR69_SOURCE} TR64_SOURCE=${TR64_SOURCE} IFX_CFLAGS="${IFX_CFLAGS}" BUILD_ROOTFS_DIR=${BUILD_ROOTFS_DIR} IFX_ROOTFS_DIR=${IFX_ROOTFS_DIR} all -C ./API -f Makefile.amz

ifx_error_check $? 

cp -f ${USER_SOURCE_DIR}ifx/tr69/API/lib/release/shared/mips-linux/lib* ${BUILD_ROOTFS_DIR}lib

ifx_error_check $?

else

	display_error "TR69 is not enabled !!"
fi
