#!/bin/sh
#TOPDIR=`pwd`/../../../../
#. ${TOPDIR}tools/build_tools/Path.sh
#tc.chen read configuration 
#. ${TOPDIR}tools/build_tools/config.sh
APPS_NAME="devm"

echo "----------------------------------------------------------------------"
echo "---------------------  build IFX TR69 Application --------------------"
echo "----------------------------------------------------------------------"

#change the following variables/flags to compile TR69 application

#Flags from Path.sh 
IFX_CFLAGS="-Os -mips32 -mtune=4kc -I/vobs/comac_amazon_lxdb1.1/source/user/ifx/IFXAPIs/include"
BUILD_ROOTFS_DIR=

#Flags from config.sh
IFX_CONFIG_TR69=1			#To build DevM or not
IFX_CONFIG_TR69_IGD=1			#To build DevM for a Gateway/Router
IFX_CONFIG_TR69_WIFILAN=0		#To include WLAN Profile to IGD
IFX_CONFIG_TR69_USBLAN=1		#To include USB Profile to IGD
IFX_CONFIG_TR69_ETHERNETLAN=1		#To include ETHERNETLAN Profile to IGD
IFX_CONFIG_TR69_ADSLWAN=1		#To include ADSLWAN Profile to IGD
IFX_CONFIG_TR69_ATMLOOPBACK=1		#To include ATMLOOPBACK Profile to IGD
IFX_CONFIG_TR69_DSLDIAGNOSTICS=1	#To include DSLDIAGNOSTICS Profile to IGD
IFX_CONFIG_LMP=1			#To include TR-064/UPnP support to IGD
IFX_CONFIG_UPNP=0			#To include UPnP support to IGD
IFX_CONFIG_TR64=1			#To include TR-064 support to IGD
IFX_CONFIG_TR69_DEVICE=0		#To build DevM for a Device
IFX_CONFIG_TR69_DEVICE_LAN=0		#To include LAN Profile to Device
IFX_CONFIG_TR69_SSL=1			#To include SSL Support to DevM
CONFIG_MATRIX=1				#To include Matrix SSL
IFX_CONFIG_TR69_TIME=1			#To include TIME Profile to IGD/Device
IFX_CONFIG_TR69_IPPING=1		#To include IPPING Profile to IGD/Device
IFX_CONFIG_TR111_STUN=0			#To include STUN Feature/Profile to IGD/Device
IFX_CONFIG_TR111_DEVICE_ASSOCIATION=0	#To include Device Association Feature/Profile to IGD/Device


IFX_CONFIG_CPU="AMAZON_SE"		#To define platform 
IFX_CONFIG_DSL_CPE_API=0		#To include dsl_api support 


#Flags from command line
STATIC=0		#Compile the libraries as static or dynamic
DEBUG=1			#Compile with debug info or not - Required to work with debugging tools
TR69DEBUG=1		#Runtime debug log messages of TR69 enabled
STANDALONE=1		#Compile standalone or across vobs
#TARGET=mips-linux	#For Target Compilation
TARGET=                 #For Host compilation
TR69SYSLOG=		#To redirect the log to the syslog daemon
TR69APPL=1		#To build as daemon or application
SSL=MATRIXSSL		#To build with Matrixtunnel support option = MATRIXSSL or OPENSSL

#End of compilation flags


CONFIG_TR69=y

if [ $IFX_CONFIG_TR69 -a "$IFX_CONFIG_TR69" = "1" ]; then

parse_args()
{
    echo parse_args
    echo $0 $1 $2 $3 $4 $5
    BUILD_CLEAN=0
    BUILD_CONFIGURE=0
    while [ $# -ge 1 ]; do
        case $1 in
        -clean)
            echo clean
            BUILD_CLEAN=1;;
        -configure)
            echo configure
            BUILD_CONFIGURE=1;;
        config_only)
            ;;
        *) build_help ;;
        esac
        shift
    done
}

parse_args $@


if [ "$1" = "config_only" ] ;then
	exit 0
fi



if [ $BUILD_CLEAN -eq 1 ]; then
        make STATIC=${STATIC} DEBUG=${DEBUG} TR69DEBUG=${TR69DEBUG} STANDALONE=${STANDALONE} TARGET=${TARGET} TR69SYSLOG=${TR69SYSLOG} TR69APPL=${TR69APPL} SSL=${SSL} IFX_CONFIG_TR69=${IFX_CONFIG_TR69} IFX_CONFIG_TR69_IGD=${IFX_CONFIG_TR69_IGD} IFX_CONFIG_TR69_WIFILAN=${IFX_CONFIG_TR69_WIFILAN} IFX_CONFIG_TR69_USBLAN=${IFX_CONFIG_TR69_USBLAN} IFX_CONFIG_TR69_ETHERNETLAN=${IFX_CONFIG_TR69_ETHERNETLAN} IFX_CONFIG_TR69_ADSLWAN=${IFX_CONFIG_TR69_ADSLWAN} IFX_CONFIG_TR69_TIME=${IFX_CONFIG_TR69_TIME} IFX_CONFIG_TR69_IPPING=${IFX_CONFIG_TR69_IPPING} IFX_CONFIG_TR69_ATMLOOPBACK=${IFX_CONFIG_TR69_ATMLOOPBACK} IFX_CONFIG_TR69_DSLDIAGNOSTICS=${IFX_CONFIG_TR69_DSLDIAGNOSTICS} IFX_CONFIG_TR111_STUN=${IFX_CONFIG_TR111_STUN} IFX_CONFIG_TR111_DEVICE_ASSOCIATION=${IFX_CONFIG_TR111_DEVICE_ASSOCIATION} IFX_CONFIG_LMP=${IFX_CONFIG_LMP} IFX_CONFIG_UPNP=${IFX_CONFIG_UPNP} IFX_CONFIG_TR64=${IFX_CONFIG_TR64} IFX_CONFIG_TR69_DEVICE=${IFX_CONFIG_TR69_DEVICE} IFX_CONFIG_TR69_DEVICE_LAN=${IFX_CONFIG_TR69_DEVICE_LAN} IFX_CONFIG_TR69_SSL=${IFX_CONFIG_TR69_SSL} CONFIG_MATRIX=${CONFIG_MATRIX} TR69_SOURCE=1 TR64_SOURCE=1 IFX_CFLAGS="${IFX_CFLAGS}" BUILD_ROOTFS_DIR=${BUILD_ROOTFS_DIR} clean -C ../cwmp
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi
        make STATIC=${STATIC} DEBUG=${DEBUG} TR69DEBUG=${TR69DEBUG} STANDALONE=${STANDALONE} TARGET=${TARGET} TR69SYSLOG=${TR69SYSLOG} TR69APPL=${TR69APPL} SSL=${SSL} IFX_CONFIG_TR69=${IFX_CONFIG_TR69} IFX_CONFIG_TR69_IGD=${IFX_CONFIG_TR69_IGD} IFX_CONFIG_TR69_WIFILAN=${IFX_CONFIG_TR69_WIFILAN} IFX_CONFIG_TR69_USBLAN=${IFX_CONFIG_TR69_USBLAN} IFX_CONFIG_TR69_ETHERNETLAN=${IFX_CONFIG_TR69_ETHERNETLAN} IFX_CONFIG_TR69_ADSLWAN=${IFX_CONFIG_TR69_ADSLWAN} IFX_CONFIG_TR69_TIME=${IFX_CONFIG_TR69_TIME} IFX_CONFIG_TR69_IPPING=${IFX_CONFIG_TR69_IPPING} IFX_CONFIG_TR69_ATMLOOPBACK=${IFX_CONFIG_TR69_ATMLOOPBACK} IFX_CONFIG_TR69_DSLDIAGNOSTICS=${IFX_CONFIG_TR69_DSLDIAGNOSTICS} IFX_CONFIG_TR111_STUN=${IFX_CONFIG_TR111_STUN} IFX_CONFIG_TR111_DEVICE_ASSOCIATION=${IFX_CONFIG_TR111_DEVICE_ASSOCIATION} IFX_CONFIG_LMP=${IFX_CONFIG_LMP} IFX_CONFIG_UPNP=${IFX_CONFIG_UPNP} IFX_CONFIG_TR64=${IFX_CONFIG_TR64} IFX_CONFIG_TR69_DEVICE=${IFX_CONFIG_TR69_DEVICE} IFX_CONFIG_TR69_DEVICE_LAN=${IFX_CONFIG_TR69_DEVICE_LAN} IFX_CONFIG_TR69_SSL=${IFX_CONFIG_TR69_SSL} CONFIG_MATRIX=${CONFIG_MATRIX} TR69_SOURCE=1 TR64_SOURCE=1 IFX_CFLAGS="${IFX_CFLAGS}" BUILD_ROOTFS_DIR=${BUILD_ROOTFS_DIR} all -C ../cwmp

else

	echo "TR69 is not enabled !!"
fi
