#!/bin/sh
#509021:linmars 2005/09/02 remove test program that used to verify adm6996 driver
APPS_NAME="ifx utilities"
if [ -e sysconfig.sh ]; then
	. sysconfig.sh
	. config.sh
	. model_config.sh
else
        echo "Application "$APPS_NAME" not configured"
        exit 0
fi                                                                                                                                       

display_info "----------------------------------------------------------------------"
display_info "-------------------- build IFX utilities -----------------------------"
display_info "----------------------------------------------------------------------"

parse_args $@

if [ "$1" = "config_only" ] ;then
	exit 0
fi

if [ $BUILD_CLEAN -eq 1 ]; then
	make clean
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

#705223:Pramod start
if [ "$IFX_CONFIG_TR69" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DTR69_DEFINED "
fi
#705223:Pramod end

if [ "$IFX_CONFIG_PORTUGESE" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DIFX_CONFIG_PORTUGESE "
fi

PLATFORM_CFLAGS="-DIFX_CONFIG_MEMORY_SIZE=${IFX_CONFIG_MEMORY_SIZE} -DIFX_CONFIG_FLASH_SIZE=${IFX_CONFIG_FLASH_SIZE} -DCPU_${IFX_CONFIG_CPU} -DIFX_BOARD_SWRESET_GPIO=${IFX_BOARD_SWRESET_GPIO}"

if [ "$IFX_CONFIG_FLASH_TYPE" = "SPI" ]; then
	PLATFORM_CFLAGS="${PLATFORM_CFLAGS} -DIFX_CONFIG_FLASH_TYPE_SPI"
fi

if [ "$IFX_ADSL_FIRMWARE_IN_ROOTFS" = "1" ]; then
       PLATFORM_CFLAGS="${PLATFORM_CFLAGS} -DIFX_ADSL_FIRMWARE_IN_ROOTFS=1"
else
       PLATFORM_CFLAGS="${PLATFORM_CFLAGS} -DIFX_ADSL_FIRMWARE_IN_ROOTFS=0"
fi

IFX_CFLAGS="${IFX_CFLAGS} ${PLATFORM_CFLAGS} -I${UBOOT_SOURCE_DIR}include"

if [ "$IFX_CONFIG_DSL_CPE_API" = "1" ]; then
	IFX_CFLAGS="${IFX_CFLAGS} -DLINUX -I${USER_IFXSOURCE_DIR}dsl_api/drv_dsl_cpe_api/src/include -I${USER_IFXSOURCE_DIR}dsl_api/dsl_cpe_control/src -DDSL_CHANNELS_PER_LINE=1"
	if [ "$IFX_CONFIG_CPU" = "AMAZON_SE" -o "$IFX_CONFIG_CPU" = "DANUBE" ]; then
        #8111001:<IFTW-linje> integrated DSL API 3.16.3
		IFX_CFLAGS="${IFX_CFLAGS} -DINCLUDE_DSL_CPE_API_DANUBE -DIFX_CONFIG_DSL_CPE_API"
		#IFX_CFLAGS="${IFX_CFLAGS} -DINCLUDE_DSL_CPE_API_${IFX_CONFIG_CPU} -DIFX_CONFIG_DSL_CPE_API"
	fi
	
fi
 

IFX_MULTILIB_UTIL="1"

#if [ "$IFX_MULTILIB_UTIL" = "1" ]; then
	#make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} STRIP=${IFX_STRIP} IFX_CFLAGS="${IFX_CFLAGS} -DBUILD_FOR_KERNEL -DIFX_MULTILIB_UTIL" IFX_LDFLAGS="${IFX_LDFLAGS}" ifx_util
#805091:<IFTW-leon>
	#make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} STRIP=${IFX_STRIP} IFX_CFLAGS="${IFX_CFLAGS} -DBUILD_FOR_KERNEL" IFX_LDFLAGS="${IFX_LDFLAGS}" swreset mknod_util status_oper next_macaddr free_dma upgrade led_control att led_test autosearch_main multicase_upgrade
# no usb_util and ledconfig
#else
	#make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} STRIP=${IFX_STRIP} IFX_CFLAGS="${IFX_CFLAGS} -DBUILD_FOR_KERNEL -DIFX_DEBUG" IFX_LDFLAGS="${IFX_LDFLAGS}" all
#fi

ifx_error_check $?


ifx_error_check $?

install -d ${BUILD_ROOTFS_DIR}usr/sbin
cp -f ifx_util ${BUILD_ROOTFS_DIR}usr/sbin
cp -f swreset ${BUILD_ROOTFS_DIR}usr/sbin
cp -f status_oper ${BUILD_ROOTFS_DIR}usr/sbin
cp -f mknod_util ${BUILD_ROOTFS_DIR}usr/sbin
cp -f next_macaddr ${BUILD_ROOTFS_DIR}usr/sbin
#805091:<IFTW-leon>
cp -f led_test ${BUILD_ROOTFS_DIR}usr/sbin
#cp -f ledconfig ${BUILD_ROOTFS_DIR}usr/sbin
cp -f led_control ${BUILD_ROOTFS_DIR}usr/sbin
cp -f att ${BUILD_ROOTFS_DIR}usr/sbin
cp -d free_dma ${BUILD_ROOTFS_DIR}usr/sbin
cp -d upgrade ${BUILD_ROOTFS_DIR}usr/sbin
#805291:<IFTW-Henry>
cp -d multicase_upgrade ${BUILD_ROOTFS_DIR}usr/sbin
#cp -d autosearch_main ${BUILD_ROOTFS_DIR}usr/sbin
cd ${BUILD_ROOTFS_DIR}usr/sbin
##########ln -fs ifx_util upgrade
#ln -fs ifx_util next_macaddr
ln -fs ifx_util get_atmqos_name
ln -fs ifx_util get_if_index
#ln -fs ifx_util swreset
#ln -fs ifx_util status_oper
#ln -fs ifx_util mknod_util
if [ "A$IFX_CONFIG_DSL_CPE_API" != "A" ]; then
	ln -fs ifx_util get_adsl_rate
fi
# 707316:leon
#ln -fs ifx_util usb_util
if [ "$IFX_CONFIG_DEBUG" = "1" ]; then
	ln -fs ifx_util mem
	ln -fs ifx_util nohup
fi
if [ "$IFX_CONFIG_VOIP" = "1" ]; then
	ln -fs ifx_util voip_relay
	ln -fs ifx_util flash_timer  # 000060:jelly:8/25
fi
ln -fs ifx_util read_img
if [ "$IFX_CONFIG_FIREWALL" = "1" -o "$IFX_CONFIG_NAPT" = "1" ]; then
	ln -fs ifx_util naptcfg
fi
if [ "$IFX_CONFIG_TR69" = "1" ]; then
	ln -fs ifx_util ifx_event_util
fi
cd -
cd ${BUILD_ROOTFS_DIR}usr/sbin
ln -fs ifx_util adm6996
if [ "$IFX_ADM6996_UTILITY" = "1" ]; then
	cd ${BUILD_ROOTFS_DIR}usr/sbin
	ln -fs ifx_util adm6996
#509021:linmars start
#	ln -fs ifx_util vlan
#509021:linmars end
	cd -
	if [ ! -d ${BUILD_ROOTFS_DIR}etc ]; then
		mkdir ${BUILD_ROOTFS_DIR}etc
		mkdir ${BUILD_ROOTFS_DIR}etc/rc.d
		mkdir ${BUILD_ROOTFS_DIR}etc/rc.d/init.d
	fi
fi

