#!/bin/sh
APPS_NAME="curl-7.17.0"
if [ -e sysconfig.sh ]; then
	. sysconfig.sh
	. config.sh
	. model_config.sh
else
        echo "Application "$APPS_NAME" not configured"
        exit 0
fi                                                                                                                                       

display_info "----------------------------------------------------------------------"
display_info "-----------------------      build curl   ------------------------"
display_info "----------------------------------------------------------------------"

parse_args $@

if [ $BUILD_CLEAN -eq 1 ]; then
	rm -rf .config_ok
	if [ -f Makefile ] ; then
		make clean
	fi
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

if [ "$1" = "config_only" -a ! -f .config_ok -o $BUILD_CONFIGURE -eq 1 ]; then
	if [ -f Makefile ] ; then
		make clean
	fi
	ifx_error_check $? 
	echo -n > .config_ok
fi

if [ "$1" = "config_only" ] ;then
	exit 0
fi

SSLOPT = --without-ssl --with-matrixssl=$PWD/../matrixssl-1-8-3-open

	./configure -host=${HOST} LD=${IFX_LD} NM=${IFX_NM} --enable-shared=yes --enable-static=no \
	--with-random --disable-file --disable-ldap --disable-dict --disable-telnet --disable-tftp\
	--disable-manual --disable-ipv6 --disable-sspi --disable-ldap --prefix=${BUILD_ROOTFS_DIR} \
	--disable-verbose --without-libssh2 --disable-largefile --without-ssl --without-zlib ${SSLOPT}



make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS}" IFX_LDFLAGS="${IFX_LDFLAGS}"
#ifx_error_check $? 

#${IFX_STRIP} lib/.libs/libcurl.so
#${IFX_STRIP} src/.libs/curl
display_info "----------------------------------------------------------------------"
display_info "-----------------------      installing curl   ------------------------"

install -m 0755  lib/.libs/libcurl.so.4.0.0 $PWD/../../../../build/root_filesystem/lib
install -d $PWD/../../../../build/root_filesystem/usr/sbin/
install -m 0755  src/.libs/curl $PWD/../../../../build/root_filesystem/usr/sbin/.
cd $PWD/../../../../build/root_filesystem/lib
ln -sf libcurl.so.4.0.0 libcurl.so.4;ln -sf libcurl.so.4.0.0 libcurl.so
ifx_error_check $? 
