#!/bin/sh
APPS_NAME="iptables"
if [ -e sysconfig.sh ]; then
	. sysconfig.sh
	. config.sh
	. model_config.sh
else
        echo "Application "$APPS_NAME" not configured"
        exit 0
fi                                                                                                                                       

display_info "----------------------------------------------------------------------"
display_info "-----------------------    build iptables-1.2.9   --------------------"
display_info "----------------------------------------------------------------------"

parse_args $@

if [ "$1" = "config_only" ] ;then
	exit 0
fi

if [ $BUILD_CLEAN -eq 1 ]; then
	make distclean
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

if [ $IFX_CONFIG_FLASH_SIZE -eq 2 ]; then
make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS}" IFX_LDFLAGS="${IFX_LDFLAGS}" KERNEL_DIR=${KERNEL_SOURCE_DIR} NO_IPV6=1 PREFIX=/usr NO_SHARED_LIBS=1 BUILD_2MB_PACKAGE=1
ifx_error_check $? 
else
make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS}" IFX_LDFLAGS="${IFX_LDFLAGS}" KERNEL_DIR=${KERNEL_SOURCE_DIR} NO_IPV6=1 PREFIX=/usr NO_SHARED_LIBS=1 BUILD_2MB_PACKAGE=0
fi

make install DESTDIR=${BUILD_ROOTFS_DIR} PREFIX=/usr NO_IPV6=1 AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS}" IFX_LDFLAGS="${IFX_LDFLAGS}" KERNEL_DIR=${KERNEL_SOURCE_DIR} NO_SHARED_LIBS=1
ifx_error_check $? 

