#!/bin/sh
APPS_NAME="matrixssl"
if [ -e sysconfig.sh ]; then
	. sysconfig.sh
	. config.sh
	. model_config.sh
else
        echo "Application "$APPS_NAME" not configured"
        exit 1
fi                                                                                                                                       

display_info "----------------------------------------------------------------------"
display_info "--------------------- build MATRIX SSL -------------------------------"
display_info "----------------------------------------------------------------------"

parse_args $@

if [ $BUILD_CLEAN -eq 1 ]; then
	make -C src clean
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

if [ "$1" = "config_only" ] ;then
	exit 0
fi

make AR="$IFX_AR" CC="$IFX_CC" RANLIB="$IFX_RANLIB" STRIP="$IFX_STRIP" IFX_CFLAGS="IFX_CFLAGS" IFX_LDFLAGS="IFX_LDFLAGS" -C src all
ifx_error_check $? 

cp -f src/libssl.so "$BUILD_ROOTFS_DIR"/lib
