#!/bin/sh
APPS_NAME="matrixtunnel"
if [ -e sysconfig.sh ]; then
	. sysconfig.sh
	. config.sh
	. model_config.sh
else
        echo "Application "$APPS_NAME" not configured"
        exit 1
fi                                                                                                                                       

display_info "----------------------------------------------------------------------"
display_info "--------------------- build MATRIX TUNNEL ----------------------------"
display_info "----------------------------------------------------------------------"

parse_args $@

if [ $BUILD_CLEAN -eq 1 ]; then
	make $clean
	if [ "$clean" = "distclean" ];then
		find . -name Makefile | xargs rm -f
		find . -name Makefile.in | xargs rm -f
		rm -rf auto* aclocal* configure
	fi
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi

if [ "$1" = "config_only" ] ;then
	exit 0
fi

if [ $BUILD_CONFIGURE -eq 1 ];then
	if [ ! -e configure ];then
		autoreconf -v --install
	fi
	./configure --prefix="$BUILD_ROOTFS_DIR" --host="$HOST" \
	--with-matrixssl-src=`cd ../matrixssl-1-8-3-open && pwd`
fi
make AR="$IFX_AR" CC="$IFX_CC" RANLIB="$IFX_RANLIB" STRIP="$IFX_STRIP" IFX_CFLAGS="IFX_CFLAGS" IFX_LDFLAGS="IFX_LDFLAGS" install
ifx_error_check $?

