/* ====================================================================
 * Copyright (c) 1997, 1998, 
 *                      SMASH, Harrie Hazewinkel.  All rights reserved.
 *
 * This product is developed by Harrie Hazewinkel and updates the
 * original SMUT compiler made as his graduation project at the
 * University of Twente.
 *
 * SMASH is a software package containing an SNMP MIB compiler and
 * an SNMP agent system. The package can be used for development
 * of monolithic SNMP agents and contains a compiler which compiles
 * MIB definitions into C-code to developed an SNMP agent.
 * More information about him and this software product can
 * be found on http://www-musiq.jrc.it/~harrie/SMASH/.
 *
 * With this file you should have received a file called
 * 'License'. If not you can pick one up from
 *
 *      http://www-musiq.jrc.it/~harrie/SMASH/licence.txt
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. All materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by Harrie Hazewinkel"
 *
 * 4. The name of the Copyright holder must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission.
 *
 * 5. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by Harrie Hazewinkel"
 *    Also acknowledged are:
 *    - The Simple group of the University of Twente,
 *          http://wwwsnmp.cs.utwente.nl/
 *    - The MUSIQ workpackage of the DESIRE project,
 *          http://www-musiq.jrc.it/
 *    - The CEO programme managing the MUSIQ workpackage,
 *          http://www.ceo.org/
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR, ITS DISTRIBUTORS
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================*/
#include        <stdio.h>
#include        <ctype.h>
#include        <stdlib.h>
#include        <string.h>
#include        <sys/types.h>
#include        <sys/time.h>
#include        <unistd.h>
#include        <netinet/in.h>
#include        <sys/socket.h>
#include        <errno.h>
#include        <net/if.h>
#include        <sys/ioctl.h>
#include        <sys/file.h>

#include    <snmp_config.h>
#include	<asn1.h>
#include	<snmp.h> 
#include	<agt_engine.h> 
#include	<snmp_community.h> 
#include	<if-mib.h> //added by Anath

#if 0
#define ifx_snmp_dbg(format, args...) printf(format, ##args)
#else
#define ifx_snmp_dbg(format, args...)
#endif

#define  SNMP_PORT       161 /* standard UDP port for SNMP agents */
#define  SNMP_PID_FILE_PREFIX "snmpd"
int	snmp_socket ;

#if 0
#define STACK_SIZE 4096
char snmpd_stack[STACK_SIZE];
void snmpdaemon(cyg_addrword_t data);
cyg_handle_t snmpd_handle;
cyg_thread snmpd_data;
cyg_thread_entry_t snmpdaemon;

int snmp_thread_counter = 0;
int snmp_thread_stop = 0;


/* 
 * The routine with which the SNMP-daemon is started.
 */
void snmpd_start()
{
	snmp_thread_stop = 0;
	if (get_snmpStatus() == 1 ) {
	        cyg_thread_create(30,
        	                snmpdaemon,
                	        (cyg_addrword_t) 0,
                        	"SNMPdaemon",
	                        (void *) snmpd_stack,
        	                STACK_SIZE,
                	        &snmpd_handle,
                        	&snmpd_data);

        	cyg_thread_resume(snmpd_handle);
		snmp_thread_counter = 1;
	}

/*	if (snmp_thread_counter &&  get_snmpStatus() == 1) 
		cyg_thread_resume(snmpd_handle);	*/
}

/* 
 * The routine with which the SNMP-daemon is stopped.
 */
void snmpd_stop()
{
	snmp_thread_stop = 1;
}

/* 
 * The routine for the SNMP-daemon.
 */
void snmpdaemon(cyg_addrword_t data)
{
	int	snmp_port;
	int	count;
	int	numfds;
	fd_set	fdset;
	snmp_port = get_snmpPort();

	struct timeval timeout;

	/* SNMP-agent initialisation functions */
	init_SNMPv2_MIB();
	init_IF_MIB();
	ensure_communities();
    
	/* Open the network */
	snmp_socket = snmp_open_connection(snmp_port);

	/* Listen to the network */
	while(1) {
		numfds = 0;
		FD_ZERO(&fdset);
		numfds = snmp_socket + 1;
		FD_SET(snmp_socket, &fdset);
	
		timeout.tv_sec = 3;
		timeout.tv_usec = 0;
	
		count = select(numfds, &fdset, 0, 0, &timeout);
		if (count > 0) {
			if (FD_ISSET(snmp_socket, &fdset)) {
				snmp_process_message(snmp_socket);
			}
		}
/*
		 else {
			switch(count) {
			case 0:
				printf("\nsnmp time out\n");
				break;
			case -1:
				if (errno == EINTR) {
					continue;
				} else {
					perror("select");
				}
			default:
				fprintf(stdout, "select returned %d\n", count);
			}
		}
*/

		//Added by Anath for SNMP Port change
		if (snmp_port != get_snmpPort()) {
			close(snmp_socket);
			snmp_socket = 0;
			snmp_port = get_snmpPort();
			snmp_socket = snmp_open_connection(snmp_port);
		}

		if (snmp_thread_stop)
		{
			if(snmp_socket)
			{
				close(snmp_socket);
				snmp_socket = 0;
			}
			cyg_thread_exit();
		}

	}
}
#endif // 0

extern int  errno;
extern int	debug_packet;
int	log_addresses = 0;
int	snmp_port = SNMP_PORT;

#if 1
char *
set_SNMPport(FILE *f, char *line)
{
  if (sscanf(line, "%d", &snmp_port) == 1) 
    return(NULL);
  else
    return("SNMP port number cannot be set");
}
#endif //0
typedef struct {
  char *keyword;
  char *(*set_variable_func)(FILE *f, char *line);
} struct_keywords;

struct_keywords configuration_keyword[] = { 
  { "sysDescr",                 set_sysDescription              },
  { "sysContact",               set_sysContact                  },
  { "sysLocation",              set_sysLocation                 },
  { "SNMPPort",                 set_SNMPport                    },
  { "community",                set_community                   }

};  

#if 1
#define NKEYWORDS    (sizeof(configuration_keyword) / sizeof(struct_keywords))

int
read_snmp_agent_configuration(char *filename)
{
  FILE *f;
  char buf[255];
  char *key, *params, *cutout ;
  int i, found;
  
  if ((f = fopen(filename, "r")) == NULL) {
    fprintf(stderr, "Fatal Error: SNMP-agent variables not set. Create \"%s\" file.\n", filename);
    return 1;
  }  

  while (!feof(f)) {
    fgets(buf, sizeof(buf), f);  
    
    key = buf;
    while(*key && isspace(*key)) key++;

    if ((*key == 0) || (*key == '#'))
      continue;

    /* Selects the keyword */
    params = key;
    while(*params && !isspace(*params)) params++;
    *params = 0;

    /* Selects parameters */
    params++;
    while(*params && isspace(*params)) params++;
    
    /* cuts spaces at the end of the parameter */
    cutout = params + strlen(params) - 1;
    while(cutout > params && isspace(*cutout)) cutout--;
    cutout++;
    *cutout = 0;
    
    if (*params) {
      i = 0;
      found = 0;
      while ((i < NKEYWORDS) && (!found)) {
        if (!strcasecmp(key, configuration_keyword[i].keyword)) {
          found = 1;
          if (configuration_keyword[i].set_variable_func(f, params) < 0) {
            fprintf(stderr, "Invalid parameters '%s' on keyword '%s'\n", params, key);
            return(1);
          }
        } else
          i++;
      }
    
      if (!found) {
        fprintf(stderr, "Keyword '%s' not recognized in file '%s'.\n", key, filename);
        return 1;
      }
    }       
  }

  fclose(f);
  return(0);
}
#endif //0
#undef  NKEYWORDS

#define IFX_PID_FILE_PATH "/var/run"

int snmp_create_pid_file(char *file_prefix)
{
   int process_id = 0;
   FILE *fp;
   char file_name[100];

	ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
   process_id = getpid();
	ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);

   sprintf(file_name,"%s/%s.pid",IFX_PID_FILE_PATH, file_prefix);	
	ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
   fp = fopen(file_name,"w");
   if (fp == NULL) {
	ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
	return -1;
   } else {
	ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
      fprintf(fp,"%d",process_id);
      fclose(fp);
   }
   //strcpy(g_ifx_pidfile_prefix, file_prefix);
   //atexit(ifx_rm_pid_file_atexit);
	ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
   return 0;
}


/* 
 * The main routine with which the SNMP-agent is started.
 */
int 	main(argc, argv)
    int	    argc;
    char    *argv[];
{
	int	count;
	int	snmp_socket;
	int	numfds;
	fd_set	fdset;
	char conf_file[100] = "/usr/sbin/snmpd.conf";
    char pid_file[50] = "/var/run/snmpd.pid";
    int  fd;
    FILE *PID;
	
	ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
	
    /* Grab the arguments */
    for(count = 1; count < argc; count++){
	if (argv[count][0] == '-'){
	    switch(argv[count][1]){
		case 'd':
		    debug_packet++;
		    break;
        case 'P':
            snmp_port = atoi(argv[++count]);
			ifx_snmp_dbg ("in file %s, fxn %s line %d, snmp_port:[%d]\n", __FILE__, __FUNCTION__,__LINE__, snmp_port);
            break;
		case 'a':
		    log_addresses++;
		    break;
		case 'p':
				ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
				// unlink(pid_file);
				ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
   				//snmp_create_pid_file(SNMP_PID_FILE_PREFIX); 
   				ifx_create_pid_file(SNMP_PID_FILE_PREFIX); 
				ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
			break;
		default:
		    printf("invalid option: -%c\n", argv[count][1]);
		    break;
	    }
	    continue;
	}
    }
	ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
    /* SNMP-agent initialisation functions */
    if (read_snmp_agent_configuration(conf_file)) {
	ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
        exit(1);
    }

	ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
    /* SNMP-agent initialisation functions */
    init_SNMPv2_MIB();
	ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
    init_IF_MIB();
	ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
    ensure_communities();
	ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
    /* Open the network */
    snmp_socket = snmp_open_connection(snmp_port);
	ifx_snmp_dbg ("in file %s, fxn %s line %d, snmpport:[%d]\n", __FILE__, __FUNCTION__, __LINE__, snmp_port);

    /* Listen to the network */
    while(1){
	ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
        numfds = 0;
        FD_ZERO(&fdset);
        numfds = snmp_socket + 1;
        FD_SET(snmp_socket, &fdset);
        count = select(numfds, &fdset, 0, 0, 0);
        if (count > 0){
            if (FD_ISSET(snmp_socket, &fdset)) {
				ifx_snmp_dbg ("in file %s, fxn %s line %d\n", __FILE__, __FUNCTION__, __LINE__);
                snmp_process_message(snmp_socket);
            }
        } else switch(count){
            case 0:
                break;
            case -1:
                if (errno == EINTR) {	continue;
                } else {		perror("select");
                }
            default:
                fprintf(stdout, "select returned %d\n", count);
        }
    }
    ifx_rm_pid_file(SNMP_PID_FILE_PREFIX);
}

