#include        <stdio.h>
#include        <ctype.h>
#include        <strings.h>



#include <sys/time.h>
//#include <linux/if.h>

#include "asn1.h"
#include "snmp.h"
#include "agt_engine.h"
#include "if-mib.h"


#include "ifx_common.h"
#include "ifx_config.h"
#include "ifx_amazon_cfg.h"
#include "ifx_api_structs.h"

#include <interfaces.h>

#if 0
#ifndef LWIP_COMPAT_SOCKETS
	#define LWIP_COMPAT_SOCKETS 1
#endif
#endif //0

#include <sys/socket.h>


#define SNMP_MAX_MSG_LENGTH             1500
#define OID_LENGTH(x)  (sizeof(x)/sizeof(oid))

#if 0
extern int   get_trapStatus();
extern int   get_trapPort();
extern char *get_trapHostIp();
#endif //0

//static struct ip_addr  get_myaddr(void);
static struct sockaddr  get_myaddr(void);


typedef void   *marker_t;
unsigned long netsnmp_get_agent_uptime(void);

static oid sysObjectID_value[] = {1,3,6,1,4,1,785,3};	//TODO use the actual enterprise oid
static oid ifAdminStatus[]     = { O_ifAdminStatus,0 }; 
static oid ifOperStatus[]      = { O_ifOperStatus,0 }; 
static oid ifIndex[]         = { O_ifIndex,0 }; 
void
send_trap_vars(int , int , int );
struct timeval  starttime;
struct trap_struct{
	unsigned char * response_version;
	unsigned char * pdu;
	unsigned char * enterprise;
	unsigned char * agent_ip;
	unsigned char * gn_trap;
	unsigned char * sp_trap;
	unsigned char * time_stamp;
	unsigned char * varbind_seq;
	unsigned char * packet_end;
	int 		packet_length;
	unsigned char 	packet[SNMP_MAX_MSG_LENGTH * 2];
	};
struct trap_struct trap_packet;
struct trap_struct* send_enterprise_trap_vars(int , int , oid * , int ,int);



unsigned char * trap_bind_var_val_list(int trap, int specific,
unsigned char *out_data,int *out_length,int interface);	
void netsnmp_get_interface_status(int interface, int *if_index, int *if_admin_status, int *if_oper_status);
#if 0
void send_easy_trap(int trap,int specific,struct netif * netif_entry)
{
	if( get_trapStatus() != 1 )
		return ;
	if(netif_entry == NULL)
		return ;
	else if (netif_entry->if_xentry.if_link_up_down_trap_enable != 1)
		return ;
	else
		send_trap_vars(trap,specific,get_interface_no(netif_entry));
}
#else
void send_easy_trap(int trap,int specific,int interface)
{
	send_trap_vars(trap,specific,interface);
}
#endif
void send_trap_vars(int trap, int specific, int interface)
{
	// FIXME: Santosh, move to new mapi
 	//int snmp_port = get_trapPort();   
	int snmp_port;

	int snmp_socket ;
	struct sockaddr_in  mySocketAddress;
	struct trap_struct * trap_msg;
	// FIXME: Santosh, move to new mapi
	//char *dest_addr = get_trapHostIp();	
	char *dest_addr;

	mySocketAddress.sin_family = AF_INET;
	inet_aton(dest_addr,&mySocketAddress.sin_addr.s_addr) ;
  	 if (sizeof (mySocketAddress.sin_port) == 2) {
        *(short *)&mySocketAddress.sin_port = htons((short) snmp_port);
   	 } else if (sizeof (mySocketAddress.sin_port) == 4) {
     	*(long *)&mySocketAddress.sin_port = htonl(snmp_port);
   	 } else {
        	return ;
    	 }

	if (trap == SNMP_TRAP_ENTERPRISESPECIFIC)
        trap_msg = send_enterprise_trap_vars(trap, specific, sysObjectID_value ,
                                  OID_LENGTH(sysObjectID_value), interface);
    	else
        trap_msg = send_enterprise_trap_vars(trap, specific, sysObjectID_value ,
                                  OID_LENGTH(sysObjectID_value), interface);
    	snmp_socket = socket(AF_INET, SOCK_DGRAM, 0);
	if(snmp_socket < 0)
	{
		// diag_printf("Unable to create socket for trap\n");
		return ;
	}
	
	//snmp_socket = snmp_open_connection(snmp_port);
#if 0
	if (lwip_sendto(snmp_socket, (char *)trap_msg->packet,
                        trap_msg->packet_length, 0,
                        (struct sockaddr *)&mySocketAddress,
                        sizeof(mySocketAddress)) < 0){
                perror("sendto");
        }
	lwip_close(snmp_socket);
#endif //0
	if (sendto(snmp_socket, (char *)trap_msg->packet,
                        trap_msg->packet_length, 0,
                        (struct sockaddr *)&mySocketAddress,
                        sizeof(mySocketAddress)) < 0){
                perror("sendto");
        }
}

struct trap_struct* send_enterprise_trap_vars(int trap, int specific, oid * enterprise_id, int oid_length, int  interface)
{
		long version = 1;
	    // FIXME: Santosh, move to new mapi
		//char *string = get_trapCommunity();	
		char *string;

		struct sockaddr agent_addr;
		unsigned long time_stamp;
		struct trap_struct * trap_pkt_ptr;

		trap_pkt_ptr = (struct trap_struct *) calloc (sizeof(struct trap_struct),1);
		unsigned char * out_data = trap_pkt_ptr->packet;
		int out_length = SNMP_MAX_MSG_LENGTH;
		out_data = asn_build_sequence(out_data, &out_length,
                (unsigned char)(ASN_SEQUENCE | ASN_CONSTRUCTOR),
                0);
        	RETURN_ON_BUILD_ERROR (out_data, "build sequence header");
 		trap_pkt_ptr->response_version = out_data;
	    	out_data = asn_build_int(out_data, &out_length,
                (unsigned char)(ASN_UNIVERSAL | ASN_PRIMITIVE | ASN_INTEGER),
                &version, sizeof(version));
    		RETURN_ON_BUILD_ERROR (out_data, "build snmp-version");

    		out_data = asn_build_string(out_data, &out_length,
                (unsigned char)(ASN_UNIVERSAL | ASN_PRIMITIVE | ASN_OCTET_STR),
                string, strlen(string));
    		RETURN_ON_BUILD_ERROR (out_data, "build snmp-version");

    		trap_pkt_ptr->pdu = out_data;
    		out_data = asn_build_sequence(out_data, &out_length,
                (unsigned char)SNMP_TRP_REQ_PDU, 0);

    		trap_pkt_ptr->enterprise = out_data;
    		out_data = asn_build_objid(out_data, &out_length,
		(unsigned char)(ASN_UNIVERSAL | ASN_PRIMITIVE | ASN_OBJECT_ID),
                 sysObjectID_value, OID_LENGTH(sysObjectID_value));
    		RETURN_ON_BUILD_ERROR(out_data, "build enterprise-id");
		
		agent_addr = get_myaddr();

    		trap_pkt_ptr->agent_ip = out_data;
    		out_data = asn_build_string(out_data, &out_length,
               (unsigned char)(ASN_UNIVERSAL | ASN_PRIMITIVE |0x40 ),
                //&agent_addr.addr, sizeof(agent_addr.addr));
                agent_addr.sa_data, sizeof(agent_addr.sa_data));
    		RETURN_ON_BUILD_ERROR(out_data, "build agent address");

    		trap_pkt_ptr-> gn_trap = out_data;
    		out_data = asn_build_int(out_data, &out_length,
                (unsigned char)(ASN_UNIVERSAL | ASN_PRIMITIVE | ASN_INTEGER),
                &trap, sizeof(trap));
    		RETURN_ON_BUILD_ERROR(out_data, "build generic trap type");

    		trap_pkt_ptr-> sp_trap = out_data;
    		out_data = asn_build_int(out_data, &out_length,
                (unsigned char)(ASN_UNIVERSAL | ASN_PRIMITIVE | ASN_INTEGER),
                &specific, sizeof(specific));
    		RETURN_ON_BUILD_ERROR (out_data, "build specific trap type");

    		time_stamp = netsnmp_get_agent_uptime();
		trap_pkt_ptr-> time_stamp = out_data;
		out_data = asn_build_unsigned_int(out_data, &out_length,
		(unsigned char)(ASN_UNIVERSAL | ASN_PRIMITIVE | 0x43),
		&time_stamp, sizeof(time_stamp));
    		RETURN_ON_BUILD_ERROR (out_data, "build timestamp");
	
		trap_pkt_ptr->varbind_seq = out_data;
		
	
		out_data = trap_bind_var_val_list(trap,specific,out_data,&out_length,interface);
	
		*out_data = NULL;
		trap_pkt_ptr-> packet_end = out_data;
		trap_pkt_ptr-> packet_length = trap_pkt_ptr-> packet_end - trap_pkt_ptr->packet;
		return trap_pkt_ptr;
}

unsigned char buffer1[100];
unsigned char buffer2[100];

unsigned char * 
trap_bind_var_val_list(int trap, int specific,unsigned char *out_data,int *out_length,int interface)	//Tapan

{
	
	int if_index = 0, if_admin_status = 0, if_oper_status = 0;
	unsigned char *ptr1 = buffer1;
	unsigned char *ptr2 = buffer2;
	
	int temp_length1 = sizeof(buffer1);
	int temp_length2 = sizeof(buffer2);
	
	
	netsnmp_get_interface_status(interface, &if_index, &if_admin_status, &if_oper_status);
	
	switch ( trap )
	{
		case 0: 	//cold reboot
//			break;
		case 1:		//warm reboot
//			break;

		case 2:		//link_down trap
				
		case 3:		//link_up trap
			
			ifIndex[sizeof(ifIndex)-1] = interface;
			ptr1 = asn_build_objid(ptr1, &temp_length1,
				(unsigned char)(ASN_UNIVERSAL | ASN_PRIMITIVE | ASN_OBJECT_ID),
		                 ifIndex, OID_LENGTH(ifIndex));
			ptr1 = asn_build_int(ptr1, &temp_length1,
		                (unsigned char)(ASN_UNIVERSAL | ASN_PRIMITIVE | ASN_INTEGER),
                		&if_index, sizeof(int));//added by AB
			
			ptr2 = asn_build_header(ptr2,&temp_length2,
		                (unsigned char)0x30    ,           //(ASN_SEQUENCE | ASN_CONSTRUCTOR),
                		sizeof(buffer1) - temp_length1);
			memcpy(ptr2,buffer1,sizeof(buffer1) - temp_length1);
			ptr2 += (sizeof(buffer1) - temp_length1);
			temp_length2 -= (sizeof(buffer1) - temp_length1);

			// commented by Santosh
			// bzero(buffer1,sizeof(buffer1));
			memset(buffer1, 0x00, sizeof(buffer1)); // added by Santosh
			temp_length1 = sizeof(buffer1);
			ptr1 = buffer1;


			ifAdminStatus[sizeof(ifAdminStatus)-1] = interface;

			ptr1 = asn_build_objid(ptr1, &temp_length1,
				(unsigned char)(ASN_UNIVERSAL | ASN_PRIMITIVE | ASN_OBJECT_ID),
		                 ifAdminStatus, OID_LENGTH(ifAdminStatus));
			ptr1 = asn_build_int(ptr1, &temp_length1,
		                (unsigned char)(ASN_UNIVERSAL | ASN_PRIMITIVE | ASN_INTEGER),
                		&if_admin_status, sizeof(int));//added by AB
			
			ptr2 = asn_build_header(ptr2,&temp_length2,
		                (unsigned char)0x30    ,           //(ASN_SEQUENCE | ASN_CONSTRUCTOR),
                		sizeof(buffer1) - temp_length1);
			memcpy(ptr2,buffer1,sizeof(buffer1) - temp_length1);
			ptr2 += (sizeof(buffer1) - temp_length1);
			temp_length2 -= (sizeof(buffer1) - temp_length1);

			// commented by Santosh
			// bzero(buffer1,sizeof(buffer1));
			memset(buffer1, 0x00, sizeof(buffer1)); // added by Santosh
			temp_length1 = sizeof(buffer1);
			ptr1 = buffer1;

			ifOperStatus[sizeof(ifOperStatus)-1] = interface;
			ptr1 = asn_build_objid(ptr1, &temp_length1,
				(unsigned char)(ASN_UNIVERSAL | ASN_PRIMITIVE | ASN_OBJECT_ID),
		                 ifOperStatus, OID_LENGTH(ifOperStatus));
			ptr1 = asn_build_int(ptr1, &temp_length1,
		                (unsigned char)(ASN_UNIVERSAL | ASN_PRIMITIVE | ASN_INTEGER),
                		&if_oper_status, sizeof(int));//added by AB
			
			ptr2 = asn_build_header(ptr2,&temp_length2,
		                (unsigned char)0x30    ,           //(ASN_SEQUENCE | ASN_CONSTRUCTOR),
                		sizeof(buffer1) - temp_length1);
			memcpy(ptr2,buffer1,sizeof(buffer1) - temp_length1);
			ptr2 += (sizeof(buffer1) - temp_length1);
			temp_length2 -= (sizeof(buffer1) - temp_length1);

			// commented by Santosh
			//bzero(buffer1,sizeof(buffer1));
			memset(buffer1, 0x00, sizeof(buffer1)); // added by Santosh
			temp_length1 = sizeof(buffer1);
			ptr1 = buffer1;

			out_data = asn_build_header(out_data,out_length,
		                (unsigned char)(ASN_SEQUENCE | ASN_CONSTRUCTOR),
                		sizeof(buffer2) - temp_length2);



			memcpy(out_data,buffer2,sizeof(buffer2) - temp_length2);

				*out_length -= (sizeof(buffer2) - temp_length2);
				out_data += (sizeof(buffer2) -temp_length2);
			break;
			
	
	}

	return out_data;
}




static struct sockaddr  get_myaddr(void)
{

	struct in_addr dest;
//	struct netif *nf ; 
	struct ifnet *ifnet;
	char *ip;
	
	
	
	// FIXME: Santosh, move to new mapi
	//ip = get_trapHostIp();

	inet_aton(ip,&dest);
	/* Finds the appropriate network interface for a given IP address */
	// FIXME: Santosh , find equi to ip_route in linux
	// nf = ip_route(&dest);
	ifnet = Get_Ifnet_From_Addr (&dest);	
	return  ifnet->if_addr;
}


/**
 * Returns the difference (in unsigned long 1/100th secs) between the two markers
 * (functionally this is what sysUpTime needs)
 */
unsigned long
uatime_hdiff(marker_t first, marker_t second)
{
    struct timeval *tv1, *tv2, diff;
    unsigned long          res;

    tv1 = (struct timeval *) first;
    tv2 = (struct timeval *) second;

    diff.tv_sec = tv2->tv_sec - tv1->tv_sec - 1;
    diff.tv_usec = tv2->tv_usec - tv1->tv_usec + 1000000;

    res = ((unsigned long) diff.tv_sec) * 100 + diff.tv_usec / 10000;
    return res;
}



 /*
 Return the value of 'sysUpTime' at the given marker
 */
unsigned long
netsnmp_marker_uptime(marker_t pm)
{
    unsigned long          res;
    marker_t        start = (marker_t) & starttime;

    res = uatime_hdiff(start, pm);
    return res;                 /* atime_diff works in msec, not csec */
}




 /*
 * struct timeval equivalents of these
 */
unsigned long
netsnmp_timeval_uptime(struct timeval * tv)
{
    return netsnmp_marker_uptime((marker_t) tv);
}


 /*
* Return the current value of 'sysUpTime'
 */
unsigned long
netsnmp_get_agent_uptime(void)
{
    struct timeval  now;
    gettimeofday(&now, NULL);

    return netsnmp_timeval_uptime(&now);
}

/*

*/
void netsnmp_get_interface_status(int interface, int *if_index, int *if_admin_status, int *if_oper_status)
{
#if 0
	struct netif *netif_entry;

	netif_entry = cyg_snmp_get_if(interface);
	*if_index = interface;
	*if_admin_status = (netif_entry->flags & NETIF_FLAG_UP ? 1 : 2);
	*if_oper_status = *if_admin_status;
#endif //0
	struct ifnet *ifnet_entry;
	char Name[16];

	*if_index = interface;
 	GetIfNameFromIndex (interface, Name);
	ifnet_entry = Get_Ifnet (interface, Name);
	*if_admin_status = (ifnet_entry->if_flags & IFF_UP ? 1 : 2);
	*if_oper_status = *if_admin_status;
}
#if 0
int get_interface_no(struct netif * nf)
{
	struct netif *ifp;
	int i = 1;

	if(nf == NULL)
		return 1;

	for( ifp = netif_list,i = 1; ifp != NULL ; i++)
	{
		if(ifp == nf)
			return i;
		ifp = ifp->next;
	}

	return 1;
}
#endif //0

