
APPS_NAME="smash-2.0.2"
if [ -e sysconfig.sh ]; then
	. sysconfig.sh
	. config.sh
	. model_config.sh
else
        echo "Application "$APPS_NAME" not configured"
        exit 0
fi                                                                                                                                       

display_info "----------------------------------------------------------------------"
display_info "-----------------------   build smash-2.0.2  ------------------------"
display_info "----------------------------------------------------------------------"

parse_args $@

IFX_CFLAGS="${IFX_CFLAGS} -DCPU_${IFX_CONFIG_CPU}"
if [ "$IFX_CONFIG_DSL_CPE_API" = "1" ]; then
        IFX_CFLAGS="${IFX_CFLAGS} -DLINUX -I${USER_IFXSOURCE_DIR}dsl_api/drv_dsl_cpe_api/src/include -I${USER_IFXSOURCE_DIR}dsl_api/dsl_cpe_control/src -DDSL_CHANNELS_PER_LINE=1"
        if [ "$IFX_CONFIG_CPU" = "AMAZON_SE" -o "$IFX_CONFIG_CPU" = "DANUBE" ]; then
                #IFX_CFLAGS="${IFX_CFLAGS} -DINCLUDE_DSL_CPE_API_${IFX_CONFIG_CPU} -DIFX_CONFIG_DSL_CPE_API"
                IFX_CFLAGS="${IFX_CFLAGS} -DINCLUDE_DSL_CPE_API_DANUBE -DIFX_CONFIG_DSL_CPE_API"
        fi

fi 

if [ $BUILD_CLEAN -eq 1 ]; then
	make -C agent clean
	make -C snmplib clean
	make -C mapi clean
	[ ! $BUILD_CONFIGURE -eq 1 ] && exit 0
fi
if [ $BUILD_CONFIGURE -eq 1 ];then

	#AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC}  RANLIB=${IFX_RANLIB}
	#BUILDCC=${IFX_HOSTCC} CXX=${IFX_CXX} OBJCOPY=${IFX_OBJCOPY} OBJDUMP=${IFX_OBJDUMP}
	#IFX_CFLAGS=${IFX_CFLAGS} IFX_LDFLAGS=${IFX_LDFLAGS} TARGET=${TARGET} HOST=${HOST} BUILD=${BUILD}
	#BUILD_ROOTFS_DIR=${BUILD_ROOTFS_DIR} ./configure --host=mips-linux CC=${IFX_CC}
	#CFLAGS=-Os -mips2 CPP=mips-linux-cpp host_alias=mips-hardhat-linux
	#--prefix=  

	#AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} \ 
	#CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} LDFLAGS="${IFX_LDFLAGS}" ./configure \
	#--target=mips-linux \
	#--host=mips-linux
	export CC="$IFX_CC"
	echo "-----------------------------------------------------------------------------------"
	CC="$IFX_CC" ./configure --host=mips-unknown-linux
	ifx_error_check $?
	echo "-----------------------------------------------------------------------------------"

	#./configure --target=mips-linux \
	#--host=mips-linux-gnu \
	#--build=i386-pc-linux-gnu --prefix="" LDFLAGS="${IFX_LDFLAGS}" \
	#--includedir="${IFX_APIS_DIR}include"

#	cd mapi
#	make CC=${IFX_CC}
#	make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} \
#	CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} \
#	CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} \
#	IFX_CFLAGS="${IFX_CFLAGS} -DIFX_SMALL_FOOTPRINT" \
#	IFX_LDFLAGS="${IFX_LDFLAGS}" BUILD_TOOLS_DIR="${BUILD_TOOLS_DIR}"
#	cp -f libsnmp_mapi.so ${BUILD_ROOTFS_DIR}lib
#	cd -

	#make CC=${IFX_CC} LDFLAGS="${IFX_LDFLAGS}" all
	make AR=${IFX_AR} AS=${IFX_AS} LD=${IFX_LD} NM=${IFX_NM} CC=${IFX_CC} BUILDCC=${IFX_HOSTCC} GCC=${IFX_CC} CXX=${IFX_CXX} CPP=${IFX_CPP} RANLIB=${IFX_RANLIB} IFX_CFLAGS="${IFX_CFLAGS} -Os" IFX_LDFLAGS="${IFX_LDFLAGS}" all
	ifx_error_check $? 

	${IFX_STRIP} --strip-unneeded agent/snmpd 
	cp -f agent/snmpd $BUILD_ROOTFS_DIR/usr/sbin/
	cp -f agent/snmpd.conf $BUILD_ROOTFS_DIR/usr/sbin/snmpd.conf
fi

