#include <time.h>
#include <errno.h>
#include <string.h>
#if 0
#include <lwip/inet.h>
#include <lwip/netif.h>
#include <lwip/api.h>
#include <lwip/sys.h>
#include <lwip/err.h>
#include <lwip/sockets.h>
#endif //0
#include <linux/inet.h>
//#include <linux/netif.h>
//#include <linux/api.h>
#include <linux/sys.h>
//#include <linux/err.h>
#include <linux/socket.h>

#include "ifx_snmp_api.h"	

#define BUFF_SIZE 512

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
//			SNMP APIS
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
/**************************************************************************
                get_snmpStatus()
**************************************************************************/
int get_snmpStatus()
{
        return (system_info.snmp_enabled);
}


/**************************************************************************
                get_snmpStatus()
**************************************************************************/
int get_trapStatus()
{
	if(system_info.snmp_enabled)
        	return (system_info.trap_enabled);
	else 
		return 0;
	
}


/**************************************************************************
                get_sysName(char **,int *)
**************************************************************************/
void get_sysName(char **name,int *len)
{
        *name = system_info.snmp.sys_name;
        *len = strlen(system_info.snmp.sys_name);
        return;
}

/**************************************************************************
		get_sysContact(char **,int *)
**************************************************************************/
void get_sysContact(char **contact,int *len)
{
	*contact = system_info.snmp.sys_contact;
	*len = strlen(system_info.snmp.sys_contact);
	return;
}

/**************************************************************************
		get_sysLocation(char **,int *)
**************************************************************************/
void get_sysLocation(char **location,int *len)
{
	*location = system_info.snmp.sys_location;
	*len = strlen(system_info.snmp.sys_location);
	return;
}

/**************************************************************************
		int get_trapPort(void)
**************************************************************************/
int get_trapPort(void)
{
	if(system_info.snmp.trap_port <= 0 ) 
		return 162;
	else
		return system_info.snmp.trap_port;
}

/**************************************************************************
		int get_snmpPort(void)
**************************************************************************/
int get_snmpPort(void)
{
	if(system_info.snmp.snmp_port <= 0 ) 
		return 161;
	else
		return system_info.snmp.snmp_port;
}



/**************************************************************************
		char * get_trapCommunity(void)
**************************************************************************/
char * get_trapCommunity(void)
{
	if(system_info.snmp.trap_community[0] == 0 ) 
		return "public";
	else
		return system_info.snmp.trap_community;
}

/**************************************************************************
		char * get_roCommunity(void)
**************************************************************************/
char * get_roCommunity(void)
{
	if(system_info.snmp.ro_community[0] == 0 ) 
		return "public";
	else
		return system_info.snmp.ro_community;
}


/**************************************************************************
		char * get_rwCommunity(void)
**************************************************************************/
char * get_rwCommunity(void)
{
	if(system_info.snmp.rw_community[0] == 0 ) 
		return "public";
	else
		return system_info.snmp.rw_community;
}

/**************************************************************************
		char * get_trapHostIp(void)
**************************************************************************/
char * get_trapHostIp(void)
{
	return system_info.snmp.traphost_ip;
}


/**************************************************************************
                set_sysName(char *)
**************************************************************************/
void set_sysName(char *name)
{
        strcpy(system_info.snmp.sys_name,name);
        return;
}


/**************************************************************************
                set_sysContact(char *)
**************************************************************************/
void set_sysContact(char *contact)
{
        strcpy(system_info.snmp.sys_contact,contact);
        return;
}

/**************************************************************************
                set_sysLocation(char *)
**************************************************************************/
void set_sysLocation(char *location)
{
        strcpy(system_info.snmp.sys_location,location);
        return;
}

