/* ====================================================================
 * Copyright (c) 1997 - 2000 
 *                      SMASH, Harrie Hazewinkel.  All rights reserved.
 *
 * This product is developed by Harrie Hazewinkel and updates the
 * original SMUT compiler made as his graduation project at the
 * University of Twente.
 *
 * SMASH is a software package containing an SNMP MIB compiler and
 * an SNMP agent system. The package can be used for development
 * of monolithic SNMP agents and contains a compiler which compiles
 * MIB definitions into C-code to developed an SNMP agent.
 * More information about him and this software product can
 * be found on http://www.simpleweb.org/software/packages/smash/.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. All materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by Harrie Hazewinkel"
 *
 * 4. The name of the Copyright holder must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission.
 *
 * 5. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by Harrie Hazewinkel"
 *    Also acknowledged are:
 *    - The Simple group of the University of Twente,
 *          http://wwwsnmp.cs.utwente.nl/
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR, ITS DISTRIBUTORS
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================*/
#include	<stdio.h>
#if 1 //added by imran
#include   <library/snmp_config.h>
#include   <sys/param.h>
#endif
#ifdef HAVE_SYS_TYPES_H
#include	<sys/types.h>
#endif
#ifdef HAVE_SYS_SOCKET_H
#include        <sys/socket.h>
//#include        <lwip/sockets.h>
#endif
#ifdef HAVE_NETINET_IN_H
#include        <netinet/in.h>
#endif
#ifdef HAVE_STRINGS_H
//#include	<strings.h> //commented by imran
#include <string.h> //added by imran
#endif

#if 1 //added by imran
#include	<library/asn1.h>
#include	<library/snmp.h>
#include	<library/agt_engine.h>
#include	<library/snmp_community.h>
#endif

#if 0
#define ifx_snmp_dbg(format, args...) printf(format, ##args)
#else
#define ifx_snmp_dbg(format, args...)
#endif

#define MAX_TOKVAL_SIZE 128

Community_t	communities[ MAX_COMMUNITIES ] = {
		{"", 0, 0, 0}, {"", 0, 0, 0}, {"", 0, 0, 0}, {"", 0, 0, 0}, {"", 0, 0, 0}, 
		{"", 0, 0, 0}, {"", 0, 0, 0}, {"", 0, 0, 0}, {"", 0, 0, 0}, {"", 0, 0, 0}} ;
int		nr_communities = 0;
int		read_write_flag = 0;


char * get_roCommunity(void)
{
	char *roCommunity = NULL, *rwCommunity = NULL, *trapIp = NULL; 
	unsigned int flags = 0;
	int ret = 0;

	ifx_snmp_dbg ("[%s]:[%d] \n", __FUNCTION__, __LINE__);
	roCommunity = (char *) malloc (MAX_TOKVAL_SIZE);
	rwCommunity = (char *) malloc (MAX_TOKVAL_SIZE);
	trapIp = (char *) malloc (MAX_TOKVAL_SIZE);
	if ((roCommunity || rwCommunity || trapIp) == NULL)	{
	    ifx_snmp_dbg ("[%s]:[%d] - error occurred while getting snmp conf info\n", __FUNCTION__, __LINE__);
		return NULL;
	}
	ifx_snmp_dbg ("[%s]:[%d] \n", __FUNCTION__, __LINE__);
	ret = IFX_SNMPd_Get_Conf_From_RcConf (&roCommunity, &rwCommunity, &trapIp, flags);                                               if (ret < 0) {
	    ifx_snmp_dbg ("[%s]:[%d] - error occurred while getting snmp conf info\n", __FUNCTION__, __LINE__);
		return "public"; // to ensure default value is returned in case of failure
	}
	ifx_snmp_dbg ("[%s]:[%d] roCommunity:[%s]\n", __FUNCTION__, __LINE__, roCommunity);
	// TODO: Santosh - free the ptrs
	return roCommunity;
	//return "public";
}
char * get_rwCommunity(void)
{
	char *roCommunity = NULL, *rwCommunity = NULL, *trapIp = NULL; 
	unsigned int flags = 0;
	int ret = 0;

	ifx_snmp_dbg ("[%s]:[%d] \n", __FUNCTION__, __LINE__);
	roCommunity = (char *) malloc (MAX_TOKVAL_SIZE);
	rwCommunity = (char *) malloc (MAX_TOKVAL_SIZE);
	ifx_snmp_dbg ("[%s]:[%d] \n", __FUNCTION__, __LINE__);
	trapIp = (char *) malloc (MAX_TOKVAL_SIZE);
	ifx_snmp_dbg ("[%s]:[%d] \n", __FUNCTION__, __LINE__);
	if ((roCommunity || rwCommunity || trapIp) == NULL)	{
	    ifx_snmp_dbg ("[%s]:[%d] - error occurred while getting snmp conf info\n", __FUNCTION__, __LINE__);
		return NULL;
	}
	ret = IFX_SNMPd_Get_Conf_From_RcConf (&roCommunity, &rwCommunity, &trapIp, flags);                                               if (ret < 0) {
	    ifx_snmp_dbg ("[%s]:[%d] - error occurred while getting snmp conf info\n", __FUNCTION__, __LINE__);
		return "private"; // to ensure default value is returned in case of failure
	}
	// TODO: Santosh - free the ptrs
	ifx_snmp_dbg ("[%s]:[%d] rwCommunity:[%s]\n", __FUNCTION__, __LINE__, rwCommunity);
	return rwCommunity;
	//return "private";
}

#if 1 //added by Anath
void set_community(char *arg, int is_write_enabled)
{

	if (is_write_enabled == 1) {
		strcpy(communities[1].string, arg);
		communities[1].length = strlen(arg);
	} else {
		strcpy(communities[0].string, arg);
		communities[0].length = strlen(arg);
	}

}
#endif

void ensure_communities(void)
{
	if (nr_communities == 0) {
		nr_communities = 2;
		// FIXME: Santosh, move to new mapi
		set_community(get_roCommunity(), 0);
		communities[0].number = 1;
		communities[0].access_flag = 1;

		// FIXME: Santosh, move to new mapi
		set_community(get_rwCommunity(), 1);
		communities[1].number = 2;
		communities[1].access_flag = 3;
	}
}


unsigned char	*snmp_parse_community(unsigned char *data, int *length,
	snmp_info_t *mesg)
{
	unsigned char		type;
	int		i;

	data = asn_parse_string(data, length, &type, 
				mesg->community, &(mesg->community_length));
	if (data == NULL){
		return NULL;
	}

#if 1 //commented by Anath
    for (i  = nr_communities - 1 ; i >= 0; i--){
	if ((mesg->community_length == communities[i].length)
		&& !(bcmp(communities[i].string, (char *)mesg->community,
						mesg->community_length))) {
	    mesg->community_id = communities[i].number;
	    read_write_flag = communities[i].access_flag;
	    return (unsigned char *)data;
	}
    }
#endif
    return NULL;
}


