#!/bin/sh

. .config
. featureconfig.sh
parse_args $@

        if [ $BUILD_CLEAN -eq 1 ]; then
                if [ ! $BUILD_CONFIGURE -eq 1 ];then
			if [ "$IFX_ADSL_FIRMWARE_IN_ROOTFS" = "1" ]; then
				rm -f ${BUILD_ROOTFS_DIR}/firmware/*
			else
                        	rm -rf ${BUILD_DIR}/firmware*
			fi
                        exit 0
                fi
        fi

	if [ "$IFX_CONFIG_DSL_CPE_API" =  "1" ]; then
		FIRMWARE_LOCATION=${USER_IFXSOURCE_DIR}dsl_api/firmware/${IFX_ADSL_FIRMWARE}
	else
		FIRMWARE_LOCATION=${USER_IFXSOURCE_DIR}adsl_firmware_loader/firmware/${IFX_ADSL_FIRMWARE}
	fi

	if [ "$IFX_ADSL_FIRMWARE_IN_ROOTFS" = "1" ]; then
		mkdir -p ${BUILD_ROOTFS_DIR}/firmware
		cp -Lf ${FIRMWARE_LOCATION} ${BUILD_ROOTFS_DIR}/firmware/modemhwe.bin
		cd ${BUILD_ROOTFS_DIR}/firmware/
		ln -fs modemhwe.bin ${IFX_ADSL_FIRMWARE}
		cd -
	fi

	if [ -n "${IFX_ADSL_FIRMWARE}" -a -f ${FIRMWARE_LOCATION} ]; then

		if [ "$IFX_ADSL_FIRMWARE_IN_ROOTFS" = "1" ]; then
			mkdir -p ${BUILD_ROOTFS_DIR}/firmware
			cp -Lf ${FIRMWARE_LOCATION} ${BUILD_ROOTFS_DIR}/firmware/modemhwe.bin
			cd ${BUILD_ROOTFS_DIR}/firmware/
			ln -fs modemhwe.bin ${IFX_ADSL_FIRMWARE}
			cd -
			exit 0
		fi

		if [ -f ${BUILD_DIR}/firmware.img ]; then
			rm -f ${BUILD_DIR}/firmware.img
		fi

		if [ -d ${BUILD_DIR}/firmware ]; then
			rm -f ${BUILD_DIR}/firmware/*
		else
			mkdir ${BUILD_DIR}/firmware
		fi

        	cp -Lf ${FIRMWARE_LOCATION} ${BUILD_DIR}/firmware/modemhwe.bin
		cd ${BUILD_DIR}/firmware/
		ln -s modemhwe.bin ${IFX_ADSL_FIRMWARE}
		cd -
		cd ${BUILD_DIR}
		chown 0.0 firmware/ -R
		grep -iq "CONFIG_SQUASHFS_LZMA=y" ${TOPDIR}/config/kernel_config
                if [ $? -eq 0 ];then
                        mksquashfs-lzma firmware/ tmp_firmware.img -be
                        mkimage -A MIPS -O Linux -C lzma -T firmware -e 0x00 -a 0x00 -n "${PLATFORM_NAME} Firmware" -d tmp_firmware.img firmware.img
                else
                        mksquashfs firmware/ tmp_firmware.img -be
                        mkimage -A MIPS -O Linux -C gzip -T firmware -e 0x00 -a 0x00 -n "${PLATFORM_NAME} Firmware" -d tmp_firmware.img firmware.img
                fi
		rm -f tmp_firmware.img
		chmod 644 firmware.img

		[ -n "${TFTP_DIR}" ] && cp -af firmware.img ${TFTP_DIR}
		cd -
	fi
