#!/bin/sh

. .config
. featureconfig.sh

TOPDIR=`cd ../../;pwd`/
CURRENTDIR=`pwd`
ONEIMAGE=ifx_adslrt.img
ONEIMAGE_TEMP=ifx_adslrt_tmp.img

if [ "$IFX_ADSL_FIRMWARE_IN_ROOTFS" = "1" ]; then
	IMAGE_LIST="rootfs.img uImage" 
else
	IMAGE_LIST="rootfs.img uImage firmware.img"
fi

cd ${BUILD_DIR}
rm -f ${ONEIMAGE}

for i in $IMAGE_LIST 
do
	if [ -e $i  ] ; then
		len=`wc -c $i | awk '{ printf $1 }'`
		pad=`expr 16 - $len % 16`
		pad=`expr $pad % 16`

		echo "Catting $i with size=$len pad=$pad to ${ONEIMAGE_TEMP}"
		if [ -e ${ONEIMAGE_TEMP}  ] ; then
			cat $i >> ${ONEIMAGE_TEMP}
		else
			cat $i > ${ONEIMAGE_TEMP}
		fi

		while [ "$pad" != "0" ]
		do
			echo "padding..."
			echo -n "0" >> ${ONEIMAGE_TEMP}
			pad=`expr $pad - 1`
		done
	else
		echo "!!!!!!!!!! $i not found !!!!!!!!!!"
	fi
done

mkimage -A MIPS -O Linux -C none -T multi -e 0x00 -a 0x00 -n "${PLATFORM_NAME} Fullimage" -d ${ONEIMAGE_TEMP} ${ONEIMAGE}

rm -f ${ONEIMAGE_TEMP}
chmod 644 ${ONEIMAGE}

[ -n "${TFTP_DIR}" ] && cp -af ${ONEIMAGE} ${TFTP_DIR}
cd -

