#!/bin/sh

## ============================================================================
## Copyright (C) 2003[- 2004] ? Infineon Technologies AG.
##
## All rights reserved.
## ============================================================================
##
## ============================================================================
##
## This document contains proprietary information belonging to Infineon 
## Technologies AG. Passing on and copying of this document, and communication
## of its contents is not permitted without prior written authorisation.
## 
## ============================================================================
##
## Create Date : 2006/07/14
## Output Files: current_config
##               current_config_model_name
##               config.sh
##               model_config.sh
##               .hhl_target_lspname
##
## Modified:
##   607141:jelly 2006/7/14 create script. (support dynamic-selected model_name feature)
##   607191:linmars 

TOPDIR=`pwd`/../../
. ./Path.sh

CONFIG_MODEL=0
CONFIG_MODEL_NAME=""

# 607141:jelly start
PLATFORM_NAME=`awk -F= '/IFX_PLATFORM_NAME/{print $2}' Path.sh`

# 607191:linmars start
search_model_id () {
	ModelNameID=0
	for ModelName in  $(find ../../config/ -type d|awk -F/ '{if (length($4)>0) {print $4}}')
	do
		# 608171:fchang.removed.start No need to check the hidden status here for creating the CDs
		# if [ -f ../../config/$ModelName/.config ] ; then 
		#	if [ $(awk -F= '/hidden/{print $2}' ../../config/$ModelName/.config) == "1" ] 
		#	then
		#		continue
		#	fi
		# fi
		# 608171:fchang.removed.end		

		ModelNameID=$(($ModelNameID+1))
		if [ "$1" = "$ModelName" ]
		then
			CONFIG_MODEL=$ModelNameID;
			break;
		fi
	done
}
# 607191:linmars end

search_model_name () {
	ModelNameID=0
	for ModelName in  $(find ../../config/ -type d|awk -F/ '{if (length($4)>0) {print $4}}')
	do
		#if [ -f ../../config/$ModelName/.config ] ; then 
		#	if [ "A$(awk -F= '/hidden/{print $2}' ../../config/$ModelName/.config)" == "A1" ] 
		#	then
		#		continue
		#	fi
		#fi
		ModelNameID=$(($ModelNameID+1))
		if [ "$1" = "$ModelNameID" ]
		then
			CONFIG_MODEL_NAME=$ModelName;
			break;
		fi
	done
}	

select_model_name () {
	if [ -e ${TOPDIR}config/current_config ] ; then
		echo "Current Configuration: `cat ../../config/current_config|tr -d [:blank:]`) $PLATFORM_NAME-`cat ../../config/current_config_model_name|tr -d [:blank:]`"
	else
		echo "Model:"
	fi
	ModelNameID=0
	for ModelName in  $(find ../../config/ -type d|awk -F/ '{if (length($4)>0) {print $4}}')
	do
		#if [ -f ../../config/$ModelName/.config ] ; then 
		#	if [ "A$(awk -F= '/hidden/{print $2}' ../../config/$ModelName/.config)" == "A1" ] 
		#	then
		#		continue
		#	fi
		#fi
		ModelNameID=$(($ModelNameID+1))
		echo "$ModelNameID) $PLATFORM_NAME-$ModelName"
	done
	echo "Please select your choice? [default:1]"
	read SelectedModelNameID

	ModelNameID=0
	for ModelName in  $(find ../../config/ -type d|awk -F/ '{if (length($4)>0) {print $4}}')
	do
		#if [ -f ../../config/$ModelName/.config ] ; then 
		#	if [ "A$(awk -F= '/hidden/{print $2}' ../../config/$ModelName/.config)" == "A1" ] 
		#	then
		#		continue
		#	fi
		#fi
		ModelNameID=$(($ModelNameID+1))
		if [ ! -n "$SelectedModelNameID" ]
		then
			CONFIG_MODEL=1
			CONFIG_MODEL_NAME=$ModelName;
			break;
		fi
		if [ "$SelectedModelNameID" -eq "$ModelNameID" ]
		then
			CONFIG_MODEL=$SelectedModelNameID
			CONFIG_MODEL_NAME=$ModelName;
			break;
		fi
	done
}

if [ ! -n "$1" -o "$1" = "-d" -a ! -n "$2" ] ; then
	while [ $CONFIG_MODEL -eq 0 ];
	do
		select_model_name
	done
fi

case "$1" in
	"")
		;;
	# 607191:linmars start 
	"-n")
		if [ "a$2" != "a" ]; then
			CONFIG_MODEL_NAME=$2
			search_model_id $CONFIG_MODEL_NAME
		else
			echo "Usage: ./build_config.sh -n model_name"
			exit 1
		fi
		if [ "$CONFIG_MODEL" = "0" ]; then
			echo "Model $CONFIG_MODEL_NAME isn't existed!"
			exit 1
		fi
		;;
	"-d")
		if [ -n "$2" ]; then 
			CONFIG_MODEL=$2
			search_model_name $CONFIG_MODEL
		else
			echo "Usage: ./build_config.sh -d model"
			exit 1
		fi 
		if [ "a$CONFIG_MODEL_NAME" = "a" ]; then
			echo "Model-ID $CONFIG_MODEL isn't existed!"
			exit 1
		fi
		;;
	# 607191:linmars end
	"-r")
		if [ -e ${TOPDIR}config/current_config ] ; then
				CONFIG_MODEL=`cat ../../config/current_config|tr -d [:blank:]`
				search_model_name $CONFIG_MODEL
		else
				echo "Please run ./build_config.sh first"
				exit 1
		fi
		;;
	*)
		echo "Usage: ./build_config.sh "
		echo "Usage: ./build_config.sh -r"
		echo "Usage: ./build_config.sh -n model_name"
		echo "Usage: ./build_config.sh -d model"
		exit 1;
		;;
esac

# clean pervious compiling stuff
if [ -e ${TOPDIR}config/current_config_model_name ]; then
	PERVIOUS_MODEL_NAME=`cat ${TOPDIR}config/current_config_model_name`
	if [ "A${CONFIG_MODEL_NAME}" != "A${PERVIOUS_MODEL_NAME}" ]; then
		echo "Cleaning pervious model[${PERVIOUS_MODEL_NAME}]!!"
		./build_clean.sh
	fi
fi

# remove preview config files and copy new config files
rm -f ${TOPDIR}config/apps_config
rm -f ${TOPDIR}config/kernel_config
rm -f ${TOPDIR}config/model_config
rm -f ${TOPDIR}config/model.h
cp -f ${TOPDIR}config/$CONFIG_MODEL_NAME/apps_config ${TOPDIR}config/
cp -f ${TOPDIR}config/$CONFIG_MODEL_NAME/kernel_config ${TOPDIR}config/
cp -f ${TOPDIR}config/$CONFIG_MODEL_NAME/model_config ${TOPDIR}config/
#cat ${TOPDIR}config/$CONFIG_MODEL_NAME/model_config > ${TOPDIR}config/model_config
#cat ${TOPDIR}config/model_config_common >> ${TOPDIR}config/model_config
cp -f ${TOPDIR}config/$CONFIG_MODEL_NAME/model.h ${TOPDIR}config/

# save current config to file
echo $CONFIG_MODEL > ${TOPDIR}config/current_config
echo $CONFIG_MODEL_NAME > ${TOPDIR}config/current_config_model_name
install -d ${BUILD_ROOTFS_DIR}etc/
echo $IFX_PACKAGE_VERSION > ${BUILD_ROOTFS_DIR}etc/version

if [ -e ${TOPDIR}config/$CONFIG_MODEL_NAME/.config ]; then
#	. ${TOPDIR}config/$CONFIG_MODEL_NAME/.config
#	if [ "A${MODEL_ROOTFS_DIRNAME}" != "A" ]; then
	NEW_ROOTFS_DIR=`awk -F= '/MODEL_ROOTFS_DIRNAME/{print $2}' ${TOPDIR}config/$CONFIG_MODEL_NAME/.config`
	if [ "A${NEW_ROOTFS_DIR}" != "A" ]; then
		NEW_ROOTFS_DIR=${TOPDIR}source/${NEW_ROOTFS_DIR}/
		sed -i -e "s:^IFX_ROOTFS_DIR.*$:IFX_ROOTFS_DIR=${NEW_ROOTFS_DIR}:g" Path.sh
	fi
fi

# link file
PlatformName=`echo $PLATFORM_NAME|tr [A-Z] [a-z]`
rm -f ${TOPDIR}source/kernel/ifx/bsp/include/asm-mips/${PlatformName}/model.h
ln -s ${TOPDIR}config/model.h ${TOPDIR}source/kernel/ifx/bsp/include/asm-mips/${PlatformName}/model.h

rm -f ${TOPDIR}source/kernel/opensource/linux-2.4.31/ifx_kernel_config
ln -s ${TOPDIR}config/kernel_config ${TOPDIR}source/kernel/opensource/linux-2.4.31/ifx_kernel_config
rm -f ${TOPDIR}source/kernel/opensource/linux-2.4.31/.config
rm -f ${TOPDIR}source/kernel/opensource/linux-2.4.31/.depend

rm -f ${TOPDIR}source/user/ifx/IFXAPIs/include/ifx_config.h
ln -s ${TOPDIR}tools/build_tools/ifx_config.h ${TOPDIR}source/user/ifx/IFXAPIs/include/ifx_config.h

# create config.sh ifx_config.h model_config.sh model_config.h
create_config

# append compiler flags 
if [ -a append_compiler_flags.sh ]
then 
	./append_compiler_flags.sh
fi

echo "${IFX_PLATFORM_NAME}-${IFX_PACKAGE_VERSION}-${CONFIG_MODEL_NAME}" > ${KERNEL_SOURCE_DIR}.hhl_target_lspname

# 607141:jelly end

#6080901:hsur  add Platform and TAPIv3 flag check 
. ./config.sh
if [ "$IFX_CONFIG_TR69" ]; then
	echo "TR69 Management is enabled on Danube"
	echo "Generating TR69 build environment"
	cd ${TOPDIR}source/user/ifx/tr69
	./site_prep.sh
	cd -
fi

if [ "$IFX_CONFIG_VOIP" -a "$PLATFORM_NAME" == "Danube" ]; then
	echo "VOIP support is enabled on Danube"
	echo "Generating VOIP build environment"
	cd ${TOPDIR}source/user/ifx/gateway-sip
	./site_prep.sh
	cd -
fi

if [ "$IFX_CONFIG_TAPIv3" -a "$PLATFORM_NAME" == "Danube" ]; then
	echo "TAPIv3 is enabled on Danube"
	if [ -e ${USER_IFXSOURCE_DIR}tapi/ucm__drv_tapi ]; then
		echo "Generating TAPIv3 drv_tapi building environment"
		rm -rf ${USER_IFXSOURCE_DIR}tapi/drv_tapi
		mkdir ${USER_IFXSOURCE_DIR}tapi/drv_tapi
		cp -afx ${USER_IFXSOURCE_DIR}tapi/ucm__drv_tapi/* ${USER_IFXSOURCE_DIR}tapi/drv_tapi

		# creating symbolic links to correct path 
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_tapi/LICENSE ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_tapi/LICENSE
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__drv_tapi/LICENSE ${USER_IFXSOURCE_DIR}tapi/drv_tapi/LICENSE
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_tapi/src/common ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_tapi/src/common
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__drv_tapi/src/common ${USER_IFXSOURCE_DIR}tapi/drv_tapi/src/common
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_tapi/src/lib/lib_bufferpool ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_tapi/src/lib/lib_bufferpool
			ln -s  ${USER_IFXSOURCE_DIR}tapi/ucm__drv_tapi/src/lib/lib_bufferpool ${USER_IFXSOURCE_DIR}tapi/drv_tapi/src/lib/lib_bufferpool
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_tapi/src/lib/lib_fifo ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_tapi/src/lib/lib_fifo
			ln -s  ${USER_IFXSOURCE_DIR}tapi/ucm__drv_tapi/src/lib/lib_fifo ${USER_IFXSOURCE_DIR}tapi/drv_tapi/src/lib/lib_fifo
		fi
	fi
	if [ -e ${USER_IFXSOURCE_DIR}tapi/ucm__drv_vmmc ]; then
		echo "Generating TAPIv3 drv_vmmc building environment"
		rm -rf ${USER_IFXSOURCE_DIR}tapi/drv_vmmc
		mkdir ${USER_IFXSOURCE_DIR}tapi/drv_vmmc
		cp -ax ${USER_IFXSOURCE_DIR}tapi/ucm__drv_vmmc/*  ${USER_IFXSOURCE_DIR}tapi/drv_vmmc

		# creating symbolic links to correct path
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_vmmc/LICENSE ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_vmmc/LICENSE
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__drv_vmmc/LICENSE ${USER_IFXSOURCE_DIR}tapi/drv_vmmc/LICENSE
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_vmmc/src/common ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_vmmc/src/common
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__drv_vmmc/src/common ${USER_IFXSOURCE_DIR}tapi/drv_vmmc/src/common
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_vmmc/src/lib/lib_bufferpool ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_vmmc/src/lib/lib_bufferpool
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__drv_vmmc/src/lib/lib_bufferpool ${USER_IFXSOURCE_DIR}tapi/drv_vmmc/src/lib/lib_bufferpool
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_vmmc/src/lib/lib_fifo ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_vmmc/src/lib/lib_fifo
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__drv_vmmc/src/lib/lib_fifo ${USER_IFXSOURCE_DIR}tapi/drv_vmmc/src/lib/lib_fifo
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_vmmc/src/lib/lib_bbd ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_vmmc/src/lib/lib_bbd
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__drv_vmmc/src/lib/lib_bbd ${USER_IFXSOURCE_DIR}tapi/drv_vmmc/src/lib/lib_bbd
		fi
	fi
	if [ -e ${USER_IFXSOURCE_DIR}tapi/ucm__drv_duslic ]; then
		echo "Generating TAPIv3 drv_duslic building environment"
		rm -rf ${USER_IFXSOURCE_DIR}tapi/drv_duslic
		mkdir ${USER_IFXSOURCE_DIR}tapi/drv_duslic
		cp -ax ${USER_IFXSOURCE_DIR}tapi/ucm__drv_duslic/*  ${USER_IFXSOURCE_DIR}tapi/drv_duslic

		# creating symbolic links to correct path
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_duslic/LICENSE ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_duslic/LICENSE
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__drv_duslic/LICENSE ${USER_IFXSOURCE_DIR}tapi/drv_duslic/LICENSE
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/common ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/common
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__drv_duslic/src/common ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/common
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/lib/lib_bufferpool ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/lib/lib_bufferpool
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__drv_duslic/src/lib/lib_bufferpool ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/lib/lib_bufferpool
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/lib/lib_fifo ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/lib/lib_fifo
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__drv_duslic/src/lib/lib_fifo ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/lib/lib_fifo
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/lib/lib_bbd ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/lib/lib_bbd
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__drv_duslic/src/lib/lib_bbd ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/lib/lib_bbd
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/mpc ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/mpc
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__drv_duslic/src/mpc ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/mpc
		fi
	fi
	cd ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src
		LC_PLATFORM_NAME=`echo ${PLATFORM_NAME}|tr "[:upper:]" "[:lower:]"`
		ln -s drv_config_user.${LC_PLATFORM_NAME}.h drv_config_user.h
	cd -
	if [ -e ${USER_IFXSOURCE_DIR}tapi/ucm__drv_daa ]; then
		echo "Generating TAPIv3 drv_daa building environment"
		rm -rf ${USER_IFXSOURCE_DIR}tapi/drv_daa
		mkdir ${USER_IFXSOURCE_DIR}tapi/drv_daa
		cp -ax ${USER_IFXSOURCE_DIR}tapi/ucm__drv_daa/*  ${USER_IFXSOURCE_DIR}tapi/drv_daa

		# creating symbolic links to correct path
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_daa/LICENSE ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_daa/LICENSE
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__drv_daa/LICENSE ${USER_IFXSOURCE_DIR}tapi/drv_daa/LICENSE
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/drv_daa/src/common ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/common
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__drv_duslic/src/common ${USER_IFXSOURCE_DIR}tapi/drv_duslic/src/common
		fi
	fi
	if [ -e ${USER_IFXSOURCE_DIR}tapi/ucm__tapidemo ]; then
		echo "Generating TAPIv3 tapidemo building environment"
		rm -rf ${USER_IFXSOURCE_DIR}tapi/tapidemo
		mkdir ${USER_IFXSOURCE_DIR}tapi/tapidemo
		cp -ax ${USER_IFXSOURCE_DIR}tapi/ucm__tapidemo/*  ${USER_IFXSOURCE_DIR}tapi/tapidemo

		# creating symbolic links to correct path
		if [ -L ${USER_IFXSOURCE_DIR}tapi/tapidemo/src/drv_duslic ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/tapidemo/src/drv_duslic
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__tapidemo/src/drv_duslic ${USER_IFXSOURCE_DIR}tapi/tapidemo/src/drv_duslic
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/tapidemo/src/drv_vmmc ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/tapidemo/src/drv_vmmc
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__tapidemo/src/drv_vmmc ${USER_IFXSOURCE_DIR}tapi/tapidemo/src/drv_vmmc
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/tapidemo/src/drv_peb3324 ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/tapidemo/src/drv_peb3324
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__tapidemo/src/drv_peb3324 ${USER_IFXSOURCE_DIR}tapi/tapidemo/src/drv_peb3324
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/tapidemo/src/system/easy3332_io.h ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/tapidemo/src/system/easy3332_io.h
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__tapidemo/src/system/easy3332_io.h ${USER_IFXSOURCE_DIR}tapi/tapidemo/src/system/easy3332_io.h
		fi
		if [ -L ${USER_IFXSOURCE_DIR}tapi/tapidemo/src/system/easy334_io.h ]; then
			rm ${USER_IFXSOURCE_DIR}tapi/tapidemo/src/system/easy334_io.h
			ln -s ${USER_IFXSOURCE_DIR}tapi/ucm__tapidemo/src/system/easy334_io.h ${USER_IFXSOURCE_DIR}tapi/tapidemo/src/system/easy334_io.h
		fi
	fi
fi #end of if [ "$IFX_CONFIG_TAPIv3" -a "$PLATFORM_NAME" == "Danube" ]

# copy DSL APIs source codes from version control server to local disk and create a build.sh link
if [ "$IFX_CONFIG_DSL_CPE_API" =  "1" ]; then
	echo "DSL_CPE_API is enabled on ${PLATFORM_NAME}."
	if [ -e ${USER_IFXSOURCE_DIR}dsl_api/ucm__drv_dsl_cpe_api ]; then
		echo "Generating DSL_CPE_API driver compiling environment"
		rm -rf ${USER_IFXSOURCE_DIR}dsl_api/drv_dsl_cpe_api
		rm -rf ${USER_IFXSOURCE_DIR}dsl_api/dsl_cpe_control
		cp -af ${USER_IFXSOURCE_DIR}dsl_api/ucm__drv_dsl_cpe_api/driver ${USER_IFXSOURCE_DIR}dsl_api/drv_dsl_cpe_api
		cp -af ${USER_IFXSOURCE_DIR}dsl_api/ucm__drv_dsl_cpe_api/application/dsl_cpe_control ${USER_IFXSOURCE_DIR}dsl_api/dsl_cpe_control
	fi
	ln -sf ${USER_IFXSOURCE_DIR}dsl_api/drv_dsl_cpe_api/src/include ${KERNEL_IFX_DIR}os/include/ifx/dsl
fi		
